--[[
	Skip's main lua
		Made by Bloops and SMS Alfredo
		With Extras and Fixes by Golden Shine and MotdSpork
		Made for DrStephen
	Enjoy!~
]]--

local SkipHUDWarning = false

if not boatchars
	rawset(_G, "boatchars", {})
end
boatchars["skip"] = {0, 1, 1}
boatchars["jana"] = {0, 1, 1}

freeslot(
	"S_PLAY_SKIPDIVE",
	"S_PLAY_CRFT",
	"S_PLAY_SKIPCANCEL",
	"S_PLAY_SKIPALTDIVE",
	"S_PLAY_SKIPCROUCH",
	"S_PLAY_SKIPDOUBLEJUMP",
	"S_PLAY_SKIPTRANSITION",
	"S_PLAY_SKIPSLIDE",
	"S_PLAY_SKIPBONK",
	"S_PLAY_SKIPJUMP",
	"S_PLAY_SKIPSMUG",
	
	"SPR_SKRP",
	"MT_SKIPMETALSCRAP",
	"S_SKIPMETALSCRAP",
	
	"SPR_FLGH",
	"MT_SKIPFLASHLIGHT",
	"S_SKIPFLASHLIGHT",
	"sfx_skpflg",
	
	"MT_SKIPRAYCAST",
	"MT_SKIPHALO",
	
	"SPR_SKSM",
	"MT_SKIPSUPERBOX",
	"S_SKIPSUPERBOX",
	
	"MT_SKIPSUPERICON",
	"S_SKIPSUPERICON1",
	"S_SKIPSUPERICON2",
	
	"sfx_skpdbl",
	"sfx_skpdbm",
	"sfx_skpms1",
	"sfx_skpms2",
	"sfx_skpchg",
	"sfx_skpwin",
	"sfx_sfstep"
)

mobjinfo[MT_SKIPMETALSCRAP] = {
	doomednum = -1,
	spawnstate = S_SKIPMETALSCRAP,
	deathstate = S_DUST1,
	xdeathstate = S_DUST1,
	spawnhealth = 1000,
	speed = 32*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_SCENERY|MF_SPECIAL|MF_SLIDEME
}

states[S_SKIPMETALSCRAP] = {SPR_SKRP, A, TICRATE*10, nil, 0, 0, S_NULL}

mobjinfo[MT_SKIPFLASHLIGHT] = {
	doomednum = -1,
	spawnstate = S_SKIPFLASHLIGHT,
	spawnhealth = 1000,
	speed = 32*FRACUNIT,
	radius = FRACUNIT,
	height = FRACUNIT,
	flags = MF_SCENERY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING
}

states[S_SKIPFLASHLIGHT] = {SPR_FLGH, FF_FULLBRIGHT|TR_TRANS70|A, 1, A_CapeChase,
24*FRACUNIT, 16*FRACUNIT, S_SKIPFLASHLIGHT}

sfxinfo[sfx_skpflg].caption = "Flashlight"

mobjinfo[MT_SKIPRAYCAST] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	speed = 64*FRACUNIT,
	radius = 64*FRACUNIT,
	height = FRACUNIT,
	flags = MF_SCENERY|MF_NOBLOCKMAP|MF_NOCLIPTHING
}

//Super Halo
mobjinfo[MT_SKIPHALO] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	speed = 32*FRACUNIT,
	radius = FRACUNIT,
	height = FRACUNIT,
	flags = MF_SCENERY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING
}

if not SuperSkipColors
	rawset(_G, "SuperSkipColors", {})
end
SuperSkipColors[SH_ARMAGEDDON] = SKINCOLOR_ORANGE
SuperSkipColors[SH_ATTRACT] = SKINCOLOR_GOLD
SuperSkipColors[SH_ELEMENTAL] = SKINCOLOR_FLAME
SuperSkipColors[SH_FORCE] = SKINCOLOR_DUSK
SuperSkipColors[SH_FORCE|1] = SKINCOLOR_PURPLE
SuperSkipColors[SH_WHIRLWIND] = SKINCOLOR_SILVER
SuperSkipColors[SH_FLAMEAURA] = SKINCOLOR_KETCHUP
SuperSkipColors[SH_BUBBLEWRAP] = SKINCOLOR_CORNFLOWER
SuperSkipColors[SH_THUNDERCOIN] = SKINCOLOR_WHITE

if not SuperSkipShields
	rawset(_G, "SuperSkipShields", {})
end
table.insert(SuperSkipShields, 0)
table.insert(SuperSkipShields, SH_ARMAGEDDON)
table.insert(SuperSkipShields, SH_ATTRACT)
table.insert(SuperSkipShields, SH_ELEMENTAL)
table.insert(SuperSkipShields, SH_FORCE|1)
table.insert(SuperSkipShields, SH_WHIRLWIND)
table.insert(SuperSkipShields, SH_FLAMEAURA)
table.insert(SuperSkipShields, SH_BUBBLEWRAP)
table.insert(SuperSkipShields, SH_THUNDERCOIN)

if not SuperSkipSounds
	rawset(_G, "SuperSkipSounds", {})
end
SuperSkipSounds[SH_ARMAGEDDON] = sfx_armasg
SuperSkipSounds[SH_ATTRACT] = sfx_attrsg
SuperSkipSounds[SH_ELEMENTAL] = sfx_elemsg
SuperSkipSounds[SH_FORCE] = sfx_frcssg
SuperSkipSounds[SH_FORCE|1] = sfx_forcsg
SuperSkipSounds[SH_WHIRLWIND] = sfx_wirlsg
SuperSkipSounds[SH_FLAMEAURA] = sfx_s3k3e
SuperSkipSounds[SH_BUBBLEWRAP] = sfx_s3k3f
SuperSkipSounds[SH_THUNDERCOIN] = sfx_s3k41

addHook("FollowMobj", function(player, mobj)
	local mo = player.mo
	A_CapeChase(mobj, 1)
	if not (mobj and mobj.valid and mo) then return true end
	
	if not player.powers[pw_super]
		if mobj.state != S_INVISIBLE
			mobj.state = S_INVISIBLE
		end
		if mobj.threshold != TICRATE/2
			mobj.threshold = TICRATE/2
			mobj.skipnext = 0
			mobj.skipprev = 0
		end
		return true
	elseif not mobj.threshold
		mobj.threshold = 1
	elseif mobj.threshold > 1
		mobj.threshold = max($ - 1, 1)
	end
	
	//Controls
	if player.cmd.buttons & BT_WEAPONNEXT and mobj.skipnext != nil
		mobj.skipnext = $ + 1
	else
		mobj.skipnext = 0
	end
	
	if player.cmd.buttons & BT_WEAPONPREV and mobj.skipprev != nil
		mobj.skipprev = $ + 1
	else
		mobj.skipprev = 0
	end
	
	//Switch shields
	if mobj.skipnext == 1 or mobj.skipprev == 1
		local id = 0
		for i, shield in ipairs(SuperSkipShields)
			if shield == player.powers[pw_shield] & SH_NOSTACK
			or (shield == SH_FORCE|1 and player.powers[pw_shield] & SH_FORCE)
				id = i
				break
			end
		end
		
		if mobj.skipnext == 1
			id = $ + 1
		else
			id = $ - 1
		end
		if id > #SuperSkipShields then id = 0
		elseif id <= 0 then id = #SuperSkipShields end
		
		player.powers[pw_shield] = ($ & SH_STACK) | (SuperSkipShields[id] or 0)
		if player.powers[pw_shield] & SH_PROTECTWATER
			if player.powers[pw_underwater] and player.powers[pw_underwater] <= 12*TICRATE + 1
				player.powers[pw_underwater] = 0
				P_RestoreMusic(player)
			else
				player.powers[pw_underwater] = 0
			end

			if player.powers[pw_spacetime] > 1
				player.powers[pw_spacetime] = 0
				P_RestoreMusic(player)
			end
		end
		
		S_StopSound(mobj)
		S_StartSound(mobj, SuperSkipSounds[player.powers[pw_shield] & SH_NOSTACK] or sfx_shield)
	end
	
	mobj.z = $ + mo.height*P_MobjFlip(mo)*5/4 - mo.momz
	P_TryMove(mobj, mobj.x - mo.momx + P_ReturnThrustX(mo, player.drawangle, -mo.radius),
	mobj.y - mo.momy + P_ReturnThrustY(mo, player.drawangle, -mo.radius), true)
	
	mobj.skin = mo.skin
	mobj.flags2 = $ &~ MF2_LINKDRAW
	
	mobj.state = S_TAILSOVERLAY_STAND
	mobj.frame = ($ &~ FF_FRAMEMASK &~ FF_TRANSMASK) | FF_TRANS20
	| abs(((player.powers[pw_super] >> 1) % 9) - 4)
	
	mobj.color = SuperSkipColors[player.powers[pw_shield] & SH_NOSTACK] or skins[mobj.skin].supercolor
	
	if not (mobj.renderflags & RF_FLOORSPRITE)
		mobj.renderflags = $ | RF_FLOORSPRITE | RF_SLOPESPLAT | RF_NOSPLATBILLBOARD | RF_FULLBRIGHT | RF_NOCOLORMAPS
		P_CreateFloorSpriteSlope(mobj)
	end
	
	local o = {x = mobj.x, y = mobj.y, z = mobj.z}
	mobj.floorspriteslope.o = o
	
	mobj.floorspriteslope.zdelta = FRACUNIT*-2/3*P_MobjFlip(mo)
	mobj.floorspriteslope.xydirection = mobj.angle
	
	mobj.spritexscale = FRACUNIT/mobj.threshold
	mobj.spriteyscale = cos(mobj.floorspriteslope.zangle)/mobj.threshold
	
	mobj.scale = mo.scale*4/5
	
	//Gold shine
	local fast = player.pflags & PF_SHIELDABILITY or mo.skipdove
	or mo.state == S_PLAY_SKIPSLIDE or mo.state == S_PLAY_SKIPTRANSITION
	
	if fast or not (leveltime % 4)
		local spark = P_SpawnMobjFromMobj(mo, 0,0,0, fast and MT_THOK or MT_OVERLAY)
		spark.state = S_NIGHTSPARKLE1
		spark.tics = 7
		
		spark.color = mobj.color
		spark.colorized = true
		
		spark.spritexoffset = P_SignedRandom()*FRACUNIT/6 + mo.spritexoffset
		spark.spriteyoffset = P_SignedRandom()*FRACUNIT/4 + player.height/2 + mo.spriteyoffset
		if mo.height <= P_GetPlayerSpinHeight(player)
		or (player.pflags & PF_JUMPED and not (player.pflags & PF_NOJUMPDAMAGE))
			spark.spriteyoffset = $*2/3
		end
		
		spark.target = mo
	end
	
	//Ghost
	if player.pflags & PF_SHIELDABILITY
		local ghost = P_SpawnGhostMobj(mo)
		P_RemoveMobj(ghost.tracer)
		
		ghost.color = mobj.color
		ghost.colorized = true
		
		ghost.fuse = 1
	end
	
	return true
end, MT_SKIPHALO)

//States
function A_SkipMinFrame(mo, var1, var2)
	mo.frame = ($ &~ FF_FRAMEMASK) | max($ & FF_FRAMEMASK, var2)
end

states[S_PLAY_SKIPDIVE] = {SPR_PLAY, SPR2_GLID, 4, nil, 0, 0, S_PLAY_SKIPDIVE}
states[S_PLAY_SKIPCROUCH] = {SPR_PLAY, SPR2_LAND, 4, nil, 0, 0, S_PLAY_SKIPCROUCH}
states[S_PLAY_CRFT] = {SPR_PLAY, SPR2_MLEL, 3, nil, 0, 0, S_PLAY_CRFT}
states[S_PLAY_SKIPCANCEL] = {SPR_PLAY, SPR2_ROLL|FF_ANIMATE, 8, nil, 8, 2, S_PLAY_JUMP}
states[S_PLAY_SKIPALTDIVE] = {SPR_PLAY, SPR2_ROLL|FF_ANIMATE, 8, nil, 8, 2, S_PLAY_SKIPDIVE}
states[S_PLAY_SKIPDOUBLEJUMP] = {SPR_PLAY, SPR2_ROLL|FF_ANIMATE, 12, nil, 8, 3, S_PLAY_JUMP}
states[S_PLAY_SKIPTRANSITION] = {SPR_PLAY, SPR2_ROLL|FF_SPR2ENDSTATE, 3, A_SkipMinFrame, S_PLAY_SKIPSLIDE, C, S_PLAY_SKIPTRANSITION}
states[S_PLAY_SKIPSLIDE] = {SPR_PLAY, SPR2_SPIN, 4, nil, 0, 0, S_PLAY_SKIPSLIDE}
states[S_PLAY_SKIPBONK] = {SPR_PLAY, SPR2_PAIN, 4, nil, 0, 0, S_PLAY_SKIPBONK}
states[S_PLAY_SKIPJUMP] = {SPR_PLAY, SPR2_LAND, 4, nil, 0, 0, S_PLAY_JUMP}
states[S_PLAY_SKIPSMUG] = {SPR_PLAY, SPR2_CLMB, 3, nil, 0, 0, S_PLAY_SKIPSMUG}

sfxinfo[sfx_skpdbl].caption = "Double Jump"
sfxinfo[sfx_skpdbm].caption = "Double Jump"
sfxinfo[sfx_skpms1].caption = "Small Scrap"
sfxinfo[sfx_skpms1].flags = SF_TOTALLYSINGLE
sfxinfo[sfx_skpms2].caption = "Big Scrap"
sfxinfo[sfx_skpms2].flags = SF_TOTALLYSINGLE
sfxinfo[sfx_skpchg].caption = "Charging"
sfxinfo[sfx_skpwin].caption = "Winner!"
sfxinfo[sfx_sfstep].caption = "Step"

//Super monitor
mobjinfo[MT_SKIPSUPERBOX] = {
	spawnstate = S_SKIPSUPERBOX,
	painstate = S_SKIPSUPERBOX,
	deathstate = S_BOX_POP1,
	deathsound = sfx_pop,
	spawnhealth = 1,
	reactiontime = 8,
	mass = 100,
	damage = MT_SKIPSUPERICON,
	speed = 1,
	radius = 18*FRACUNIT,
	height = 40*FRACUNIT,
	flags = MF_SOLID|MF_SHOOTABLE|MF_MONITOR,
}
states[S_SKIPSUPERBOX] = {SPR_SKSM, 0, 2, nil, 0, 0, S_BOX_FLICKER}

function A_SkipSuper(mobj)
	local mo = mobj.target
	local player = mo and mo.player
	if not player then return end
	
	if not All7Emeralds(emeralds)
	or (solchars and solchars[mo.skin] and solchars[mo.skin][2] == 1)
		A_SuperSneakers(mobj)
		A_Invincibility(mobj)
		
	elseif player.powers[pw_super] or player.skipsuper
		S_StartSound(mo, sfx_itemup)
		P_GivePlayerRings(player, 50)
	else
		player.skipsuper = true
		player.charflags = $ | SF_SUPER
	
		P_DoSuperTransformation(player, true)
	end
end

mobjinfo[MT_SKIPSUPERICON] = {
	spawnstate = S_SKIPSUPERICON1,
	deathstate = S_BOX_POP1,
	spawnhealth = 1,
	reactiontime = 8,
	mass = 100,
	damage = 62*FRACUNIT,
	speed = 2*FRACUNIT,
	radius = 8*FRACUNIT,
	height = 14*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY|MF_NOGRAVITY|MF_BOXICON,
}
states[S_SKIPSUPERICON1] = {SPR_SKSM, FF_ANIMATE|2, 18, nil, 3, 4, S_SKIPSUPERICON2}
states[S_SKIPSUPERICON2] = {SPR_SKSM, 2, 18, A_SkipSuper, 0, 0, S_NULL}

//List of monitors
local skipcraftlist = {
	[0] = MT_PITY_BOX,
	MT_EGGMAN_BOX,
	MT_SNEAKERS_BOX,
	MT_FORCE_BOX,
	MT_ATTRACT_BOX,
	MT_BUBBLEWRAP_BOX,
	MT_MYSTERY_BOX,
	MT_ARMAGEDDON_BOX,
	MT_ELEMENTAL_BOX,
	MT_INVULN_BOX,
	MT_FLAMEAURA_BOX,
	MT_WHIRLWIND_BOX,
	MT_THUNDERCOIN_BOX,
	MT_SKIPSUPERBOX,
}

//Cost for each monitor
local skipcost = {
	[MT_PITY_BOX] = 10,
	[MT_EGGMAN_BOX] = 10,
	[MT_SNEAKERS_BOX] = 15,
	[MT_FORCE_BOX] = 20,
	[MT_ATTRACT_BOX] = 25,
	[MT_BUBBLEWRAP_BOX] = 30,
	[MT_MYSTERY_BOX] = 30,
	[MT_ARMAGEDDON_BOX] = 35,
	[MT_ELEMENTAL_BOX] = 40,
	[MT_INVULN_BOX] = 45,
	[MT_FLAMEAURA_BOX] = 50,
	[MT_WHIRLWIND_BOX] = 55,
	[MT_THUNDERCOIN_BOX] = 60,
	[MT_SKIPSUPERBOX] = 60,
}

//List of Passive Abilities
local skippassive = {
	[MT_PITY_BOX] = "\x84 Passive:\x80 None",
	[MT_EGGMAN_BOX] = "\x84 Passive:\x80 It's",
	[MT_SNEAKERS_BOX] = "\x84 Passive:\x80 Increased",
	[MT_FORCE_BOX] = "\x84 Passive:\x80 Two Hit Points",
	[MT_ATTRACT_BOX] = "\x84 Passive:\x80 Ring Attraction",
	[MT_BUBBLEWRAP_BOX] = "\x84 Passive:\x80 Infinite Air",
	[MT_MYSTERY_BOX] = "\x84 Passive:\x80 Gain a",
	[MT_ARMAGEDDON_BOX] = "\x84 Passive:\x80 Explodes on Contact",
	[MT_ELEMENTAL_BOX] = "\x84 Passive:\x80 Fire/Water Protection",
	[MT_INVULN_BOX] = "\x84 Passive:\x80 Invincible",
	[MT_FLAMEAURA_BOX] = "\x84 Passive:\x80 Fire Protection",
	[MT_WHIRLWIND_BOX] = "\x84 Passive:\x80 None",
	[MT_THUNDERCOIN_BOX] = "\x84 Passive:\x80 Ring Attraction",
	[MT_SKIPSUPERBOX] = "\x84 Passive:\x80 Invincible and",
}

//List of Active Abilities
local skipactive = {
	[MT_PITY_BOX] = "\x83 Active:\x80 None",
	[MT_EGGMAN_BOX] = "a Trap!",
	[MT_SNEAKERS_BOX] = "Speed Temporarily",
	[MT_FORCE_BOX] = "\x83 Active:\x80 Wall Jump Dive",
	[MT_ATTRACT_BOX] = "\x83 Active:\x80 Homing Dive",
	[MT_BUBBLEWRAP_BOX] = "\x83 Active:\x80 Bounce Dive",
	[MT_MYSTERY_BOX] = "Random Powerup",
	[MT_ARMAGEDDON_BOX] = "\x83 Active:\x80 Charge Dive",
	[MT_ELEMENTAL_BOX] = "\x83 Active:\x80 Meteor Dive",
	[MT_INVULN_BOX] = "Temporarily",
	[MT_FLAMEAURA_BOX] = "\x83 Active:\x80 Burst Dive",
	[MT_WHIRLWIND_BOX] = "\x83 Active:\x80 High Dive",
	[MT_THUNDERCOIN_BOX] = "\x83 Active:\x80 Wire Dive",
	[MT_SKIPSUPERBOX] = "Increased Speed Temporarily",
}

//Total number of monitors (minus one of course since it's zero-indexed)
local skiptotalcraft = #skipcraftlist

//Add a monitor to Skip's list
rawset(_G, "AddSkipMonitor", function(mobjtype, cost, passive, active)
	skiptotalcraft = $+1
	skipcraftlist[skiptotalcraft] = mobjtype
	skipcost[mobjtype] = cost
	skippassive[mobjtype] = passive
	skipactive[mobjtype] = active
	return id
end)

//Built-in Monitor support
local ShadowLoaded = false
local CherryLoaded = false
local CustomLoaded = false
local PlusLoaded = false
local ESPLoaded = false
addHook("ThinkFrame", do
	if not ShadowLoaded and pcall(function() local v = _G["MT_SHADOW_BOX"] end, "MT_SHADOW_BOX")
		AddSkipMonitor(MT_SHADOW_BOX, 15, "\x84 Passive:\x80 ???", "\x83 Active:\x80 ???")
		ShadowLoaded = true
	end
	
	if not CherryLoaded and pcall(function() local v = _G["MT_COPYPLAYER_BOX"] end, "MT_COPYPLAYER_BOX")
		AddSkipMonitor(MT_COPYPLAYER_BOX, 15, "\x84 Passive:\x80 Creates a", "clone of yourself")
		CherryLoaded = true
	end
	
	if not CustomLoaded and pcall(function() local v = _G["MT_SEMISUPERMONITOR"] end, "MT_SEMISUPERMONITOR")
		AddSkipMonitor(MT_POWERFUL5MONITOR, 5, "\x83 Active:\x80 Five Ringslingers", "using Custom 3")
		AddSkipMonitor(MT_SEMISUPERMONITOR, 60, "\x84 Passive:\x80 Increased Speed", "and Invincible Temporarily")
		AddSkipMonitor(MT_MEGAMUSHROOMMONITOR, 75, "\x84 Passive:\x80 Giant Size", "Temporarily")
		AddSkipMonitor(MT_REDSTARMONITOR, 100, "\x83 Active:\x80 Free-Flight", "using Custom 2/3")
		CustomLoaded = true
	end
	
	if not PlusLoaded and pcall(function() local v = _G["MT_ICESHIELD_BOX"] end, "MT_ICESHIELD_BOX")
		AddSkipMonitor(MT_SPIKESHIELD_BOX, 15, "\x84 Passive:\x80 Spike Protection", "\x83 Active:\x80 Roll Crouch")
		AddSkipMonitor(MT_MOMENTUMSHIELD_BOX, 20, "\x84 Passive:\x80 Momentum Mod", "\x83 Active:\x80 Redirect Dive")
		AddSkipMonitor(MT_ICESHIELD_BOX, 35, "\x84 Passive:\x80 Ice Physics", "\x83 Active:\x80 CA_TELEKINESIS")
		AddSkipMonitor(MT_METALSHIELD_BOX, 40, "\x84 Passive:\x80 Increased Gravity", "and Spike/Fire Protection")
		AddSkipMonitor(MT_HOVERSHIELD_BOX, 50, "\x84 Passive:\x80 Water Run", "\x83 Active:\x80 Float Dive")
		AddSkipMonitor(MT_BUMPERSHIELD_BOX, 60, "\x84 Passive:\x80 Wall Bounce", "\x83 Active:\x80 Fall Switch Dive")
		
		SuperSkipColors[SH_ICESHIELD] = SKINCOLOR_ICY
		SuperSkipSounds[SH_ICESHIELD] = sfx_shattr
		table.insert(SuperSkipShields, SH_ICESHIELD)
		
		SuperSkipColors[SH_HOVERSHIELD] = SKINCOLOR_SLATE
		SuperSkipSounds[SH_HOVERSHIELD] = sfx_ncchip
		table.insert(SuperSkipShields, SH_HOVERSHIELD)
		
		SuperSkipColors[SH_METALSHIELD] = SKINCOLOR_BLACK
		SuperSkipSounds[SH_METALSHIELD] = sfx_spsmsh
		table.insert(SuperSkipShields, SH_METALSHIELD)
		
		SuperSkipColors[SH_SPIKESHIELD] = SKINCOLOR_GREY
		SuperSkipSounds[SH_SPIKESHIELD] = sfx_spkdth
		table.insert(SuperSkipShields, SH_SPIKESHIELD)
		
		SuperSkipColors[SH_BUMPERSHIELD] = SKINCOLOR_RED
		SuperSkipSounds[SH_BUMPERSHIELD] = sfx_s3kaa
		table.insert(SuperSkipShields, SH_BUMPERSHIELD)
		
		SuperSkipColors[SH_MOMENTUMSHIELD] = SKINCOLOR_EMERALD
		SuperSkipSounds[SH_MOMENTUMSHIELD] = sfx_spdpad
		table.insert(SuperSkipShields, SH_MOMENTUMSHIELD)
		
		PlusLoaded = true
	end
	
	if not ESPLoaded and pcall(function() local v = _G["MT_GRAVITORB_BOX"] end, "MT_GRAVITORB_BOX")
		AddSkipMonitor(MT_COMBINE_BOX, 10, "\x84 Passive:\x80 Combines Spilled", "Rings Into One")
		AddSkipMonitor(MT_GRUSH_BOX, 15, "\x84 Passive:\x80 Double", "Rings Temporarily")
		AddSkipMonitor(MT_SOCKS_BOX, 15, "\x84 Passive:\x80 Increased Jump", "Height Temporarily")
		AddSkipMonitor(MT_STAR_BOX, 20, "\x84 Passive:\x80 None", "\x83 Active:\x80 Lightdash Dive")
		AddSkipMonitor(MT_CLOCK_BOX, 30, "\x84 Passive:\x80 None", "\x83 Active:\x80 Time Warp")
		AddSkipMonitor(MT_GUM_BOX, 40, "\x84 Passive:\x80 None", "\x83 Active:\x80 Glide Dive")
		AddSkipMonitor(MT_GRAVITORB_BOX, 100, "\x84 Passive:\x80 None", "\x83 Active:\x80 Grav-Flip Dive")
		
		SuperSkipColors[SH_STAR] = SKINCOLOR_PASTEL
		SuperSkipSounds[SH_STAR] = sfx_s227
		//table.insert(SuperSkipShields, SH_STAR) //Unfortunately does not work
		
		SuperSkipColors[SH_CLOCK] = SKINCOLOR_SILVER
		SuperSkipSounds[SH_CLOCK] = sfx_kc31
		//table.insert(SuperSkipShields, SH_CLOCK) //Unfortunately does not work
		
		SuperSkipColors[SH_GRAVITY] = SKINCOLOR_ORANGE
		SuperSkipSounds[SH_GRAVITY] = sfx_peww
		table.insert(SuperSkipShields, SH_GRAVITY)
		
		SuperSkipColors[SH_GUM] = SKINCOLOR_BUBBLEGUM
		SuperSkipSounds[SH_GUM] = sfx_s3k8a
		table.insert(SuperSkipShields, SH_GUM)

		ESPLoaded = true
	end
	
	for player in players.iterate
		if player.mo and player.mo.valid and player.mo.skin == "skip"
		and player.mo.skipdove and (player.panim == PA_RIDE
		or (player.panim >= PA_IDLE and player.panim <= PA_DASH)
		or (player.panim >= PA_JUMP and player.panim <= PA_FALL))
			player.mo.state = player.mo.starlightdash and S_PLAY_SKIPALTDIVE or S_PLAY_SKIPDIVE
		end
	end
end)

//This is a bit stupid
local skipreloadcustomshield = function(player)
	if PlusLoaded
		if player.powers[pw_shield] == SH_ICESHIELD
			local mobz = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_ICESHIELD)
			mobz.target = player.mo
		elseif player.powers[pw_shield] == SH_HOVERSHIELD
			local mobz = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_HOVERSHIELD)
			mobz.target = player.mo
		elseif player.powers[pw_shield] == SH_METALSHIELD
			local mobz = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_METALSHIELD)
			mobz.target = player.mo
		elseif player.powers[pw_shield] == SH_SPIKESHIELD
			local mobz = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SPIKESHIELD)
			mobz.target = player.mo
		elseif player.powers[pw_shield] == SH_BUMPERSHIELD
			local mobz = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_BUMPERSHIELD)
			mobz.target = player.mo
		elseif player.powers[pw_shield] == SH_MOMENTUMSHIELD
			local mobz = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_MOMENTUMSHIELD)
			mobz.target = player.mo
		end
	end
	
	if ESPLoaded
		if player.powers[pw_shield] == SH_GRAVITY
		or player.powers[pw_shield] == SH_STAR
		or player.powers[pw_shield] == SH_CLOCK
		or player.powers[pw_shield] == SH_GUM
			local extraorb = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_EXTRA_ORB)
			extraorb.target = player.mo
		end
	end
end

//Additional Scrap for certain enemies
rawset(_G, "SkipBadnikScrap", {
	[MT_JETTBOMBER] = 6,
	[MT_JETTGUNNER] = 6,
	[MT_CRAWLACOMMANDER] = 10,
	[MT_CRUSHSTACEAN] = 9,
	[MT_BANPYURA] = 9,
	[MT_POINTY] = 9,
	[MT_EGGGUARD] = 8,
	[MT_FACESTABBER] = 10,
	[MT_GSNAPPER] = 9,
	[MT_MINUS] = 6,
	[MT_UNIDUS] = 8,
	[MT_PYREFLY] = 9,
	[MT_DRAGONBOMBER] = 12,
	[MT_TURRET] = 6,
	[MT_CACOLANTERN] = 9,
	[MT_SPINBOBERT] = 6,
	[MT_GOOMBA] = 0,
	[MT_BLUEGOOMBA] = 0,
})

//Color table for the different badniks
//Default color is Cloudy
rawset(_G, "SkipBadnikColor", {
	[MT_BLUECRAWLA] = SKINCOLOR_AZURE,
	[MT_REDCRAWLA] = SKINCOLOR_RED,
	[MT_GFZFISH] = SKINCOLOR_BLUE,
	[MT_GOLDBUZZ] = SKINCOLOR_GOLD,
	[MT_REDBUZZ] = SKINCOLOR_RED,
	[MT_JETTBOMBER] = SKINCOLOR_APPLE,
	[MT_JETTGUNNER] = SKINCOLOR_GOLD,
	[MT_CRAWLACOMMANDER] = SKINCOLOR_BLUE,
	[MT_DETON] = SKINCOLOR_RED,
	//MT_SKIM
	[MT_TURRET] = SKINCOLOR_DUSK,
	[MT_POPUPTURRET] = SKINCOLOR_GREY,
	[MT_SPINCUSHION] = SKINCOLOR_CERULEAN,
	[MT_CRUSHSTACEAN] = SKINCOLOR_RED,
	[MT_BANPYURA] = SKINCOLOR_AQUA,
	[MT_JETJAW] = SKINCOLOR_ORANGE,
	[MT_SNAILER] = SKINCOLOR_RED,
	[MT_VULTURE] = SKINCOLOR_RED,
	[MT_POINTY] = SKINCOLOR_CERULEAN,
	[MT_ROBOHOOD] = SKINCOLOR_GREEN,
	[MT_FACESTABBER] = SKINCOLOR_RED,
	[MT_EGGGUARD] = SKINCOLOR_LILAC,
	[MT_GSNAPPER] = SKINCOLOR_GREEN,
	//MT_MINUS
	[MT_SPRINGSHELL] = SKINCOLOR_BLUEBELL,
	[MT_YELLOWSHELL] = SKINCOLOR_ORANGE,
	[MT_UNIDUS] = SKINCOLOR_JET,
	//MT_CANARIVORE
	[MT_PYREFLY] = SKINCOLOR_CRIMSON,
	[MT_PTERABYTE] = SKINCOLOR_LILAC,
	[MT_DRAGONBOMBER] = SKINCOLOR_JET,
	[MT_PENGUINATOR] = SKINCOLOR_BLUE,
	[MT_POPHAT] = SKINCOLOR_AETHER,
	[MT_HIVEELEMENTAL] = SKINCOLOR_YELLOW,
	[MT_BUMBLEBORE] = SKINCOLOR_YELLOW,
	[MT_BUGGLE] = SKINCOLOR_AZURE,
	[MT_CACOLANTERN] = SKINCOLOR_ORANGE,
	[MT_SPINBOBERT] = SKINCOLOR_AETHER,
	[MT_HANGSTER] = SKINCOLOR_PURPLE,
	[MT_METALSONIC_BATTLE] = SKINCOLOR_COBALT,
	[MT_BLACKEGGMAN] = SKINCOLOR_BLACK,
	[MT_CYBRAKDEMON] = SKINCOLOR_BLACK,
})

//Do we have a Skip buddy?
local function skipbuddy(player)
	if player.buddies and #player.buddies
		for id,buddy in pairs(player.buddies) do
			if buddy.skin == "skip"
				return true
			end
		end
	end
end

//Command to enable infinite scrap
CV_RegisterVar({
	name = "infinitescrap",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_SHOWMODIF|CV_CHEAT,
	PossibleValue = CV_OnOff
})

//Skip's HUD and Menu
//along with a very dangerous chasecam variable
local verydangerouschasecamvariable = true
hud.add(function(v, player, cam)
	verydangerouschasecamvariable = cam.chase
	if not (player.mo and player.mo.valid and player.skipscrap != nil
	and (player.mo.skin == "skip" or skipbuddy(player))
	and not G_IsSpecialStage()) return end
	
	//
	//Scrap HUD
	//
	
	local ypos = 168
	if player.buddies and #player.buddies
		ypos = $-10
	end
	
	//Metal Graphic
	v.draw(24,ypos,v.getSpritePatch(SPR_SKRP),
	V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT, v.getColormap(nil, SKINCOLOR_CLOUDY))
	
	//X (changes position based on the number of digits)
	if player.skipscrap >= 100000
		//
	elseif player.skipscrap >= 10000
		v.draw(28,ypos,v.cachePatch("STLIVEX"),
		V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
	elseif player.skipscrap >= 1000
		v.draw(36,ypos,v.cachePatch("STLIVEX"),
		V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
	else
		v.draw(38,ypos,v.cachePatch("STLIVEX"),
		V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
	end
	
	//The number itself
	if CV_FindVar("infinitescrap").value
		v.drawString(74,ypos-2,"",
		V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT, "right")
	else
		v.drawString(74,ypos-2,player.skipscrap,
		V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT, "right")
	end
	
	//
	//Crafting Menu
	//
	
	if player.skipyoffset
		local selectgraphic = "SKIPNORM"
		if All7Emeralds(emeralds) then selectgraphic = "SKIPGOLD" end
		v.drawScaled(110*FRACUNIT, (200-(player.skipyoffset*5))*FRACUNIT, FRACUNIT/2,
		v.cachePatch(selectgraphic),V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)
		
		local selection = skipcraftlist[player.skipselection]
		local superduper = selection == MT_SKIPSUPERBOX and All7Emeralds(emeralds)
		
		if player.lefttapping or player.righttapping
			v.draw(160,(227-(player.skipyoffset*5)),
			v.cachePatch("SKIPSTAT"), V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)
			
			v.drawScaled(133*FRACUNIT, (223-(player.skipyoffset*5))*FRACUNIT, FRACUNIT/2,
			v.cachePatch("SKIPSTAT"), V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)
		
			v.drawScaled(121*FRACUNIT,(223-(player.skipyoffset*5))*FRACUNIT, FRACUNIT/2,
			v.cachePatch("SKIPSTAT"),V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)
		
			v.drawScaled(187*FRACUNIT,(223-(player.skipyoffset*5))*FRACUNIT, FRACUNIT/2,
			v.cachePatch("SKIPSTAT"),V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)

			v.drawScaled(199*FRACUNIT,(223-(player.skipyoffset*5))*FRACUNIT, FRACUNIT/2,
			v.cachePatch("SKIPSTAT"),V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)
		else
			local patch = v.getSpritePatch(states[mobjinfo[selection].spawnstate].sprite, 2)
			if not patch then patch = v.getSpritePatch(states[mobjinfo[selection].spawnstate].sprite, 0) end
			
			v.draw(160,(227-(player.skipyoffset*5)), patch,
			V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)
		
			selectgraphic = player.skipselection-1
			if selectgraphic < 0 then selectgraphic = $+skiptotalcraft+1 end
			v.drawScaled(133*FRACUNIT, (223-(player.skipyoffset*5))*FRACUNIT, FRACUNIT/2,
			v.getSpritePatch(states[mobjinfo[skipcraftlist[selectgraphic]].spawnstate].sprite, 2),
			V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)
		
			selectgraphic = player.skipselection-2
			if selectgraphic < 0 then selectgraphic = $+skiptotalcraft+1 end
			v.drawScaled(121*FRACUNIT, (223-(player.skipyoffset*5))*FRACUNIT, FRACUNIT/2,
			v.getSpritePatch(states[mobjinfo[skipcraftlist[selectgraphic]].spawnstate].sprite, 2),
			V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)
		
			selectgraphic = player.skipselection+1
			if selectgraphic > skiptotalcraft then selectgraphic = $-(skiptotalcraft+1) end
			v.drawScaled(187*FRACUNIT, (223-(player.skipyoffset*5))*FRACUNIT, FRACUNIT/2,
			v.getSpritePatch(states[mobjinfo[skipcraftlist[selectgraphic]].spawnstate].sprite, 2),
			V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)
		
			selectgraphic = player.skipselection+2
			if selectgraphic > skiptotalcraft then selectgraphic = $-(skiptotalcraft+1) end
			v.drawScaled(199*FRACUNIT, (223-(player.skipyoffset*5))*FRACUNIT, FRACUNIT/2,
			v.getSpritePatch(states[mobjinfo[skipcraftlist[selectgraphic]].spawnstate].sprite, 2),
			V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)
		end
		
		local monitorcost = skipcost[selection] //Cost
		if type(monitorcost) != "number" then monitorcost = 15 end
		if All7Emeralds(emeralds)
			monitorcost = FixedFloor($*FRACUNIT*3/4)/FRACUNIT //Emerald Discount
			v.drawScaled(174*FRACUNIT,(226-(player.skipyoffset*5))*FRACUNIT, FRACUNIT/2,
			v.cachePatch("SKIPEMER"), V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER)
		end
		v.drawString(160, 248-(player.skipyoffset*5), "\x82 Cost:\x80 "..monitorcost,
		V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER, "thin-center")
		
		local description = skippassive[selection]
		if superduper then description = "\x84 Passive:\x80 Turn Super" end
		if description
			v.drawString(160, 255-(player.skipyoffset*5), description,
			V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER, "thin-center")
		end
		
		description = skipactive[selection]
		if superduper then description = "\x83 Wpn Prev/Next:\x80 Swap Shields" end
		if description
			v.drawString(160, 262-(player.skipyoffset*5), description,
			V_HUDTRANS|V_SNAPTOBOTTOM|V_PERPLAYER, "thin-center")
		end
	end
end)

//Reset Skip's variables
local function resetskip(player)
	if player.mo and player.mo.valid
		if player.skipsmug
			if player.mo.state == S_PLAY_SKIPSMUG
				player.mo.state = S_PLAY_STND
			end
			P_RestoreMusic(player)
			player.skipsmug = false
		end
		if player.mo.skipdove
			player.mo.skipdove = false
			player.pflags = $&~PF_DRILLING
		end
		if player.mo.skipdivehit
			player.mo.skipdivehit = 0
			player.mo.rollangle = 0
		end
		player.mo.skipsteam = false
		player.mo.skipperfectwindow = 0
		player.mo.skipcrouching = false
		player.mo.skipwiredive = 0
		player.mo.skipwiredivedir = player.drawangle
		player.mo.skipchargedive = 0
		player.mo.skipmenu = false
		player.mo.skipcrouchdir = 0
		if player.height == skins[player.mo.skin].spinheight
			player.height = skins[player.mo.skin].height
		end
		if player.normalspeed == 0
			player.normalspeed = skins[player.mo.skin].normalspeed
		end
	end
end

//Set the dive momentum
local function skipdive(player)
	if player.mo and player.mo.valid and player.mo.skin == "skip"
		local returnvalue = player.speed
		if (player.powers[pw_shield] & SH_NOSTACK) == SH_FLAMEAURA
		or ((player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
		and not P_IsObjectOnGround(player.mo))
			player.pflags = $|PF_SHIELDABILITY
			S_StartSound(player.mo, sfx_s3k43)
			returnvalue = 60*player.mo.scale
		elseif player.speed >= 40*player.mo.scale
			returnvalue = player.speed + FixedMul((player.actionspd/4), player.mo.scale)
		elseif player.speed > 5*player.mo.scale or player.speed == 5*player.mo.scale
			returnvalue = player.speed + FixedMul((player.actionspd/3), player.mo.scale)
		else
			returnvalue = FixedMul(player.actionspd/(3/2), player.mo.scale)
		end
		
		//Speed Cap
		if player.mysticsuper
			if returnvalue > player.mo.scale*140 --Increased speed cap for Mystic Super!
			returnvalue = player.mo.scale*140
			end
		elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
		and returnvalue > player.mo.scale*60
			returnvalue = player.mo.scale*60
		elseif returnvalue > player.mo.scale*80
			returnvalue = player.mo.scale*80
		end
		
		//Increase the speed when you're on the ground to circumvent speed loss
		if P_IsObjectOnGround(player.mo)
			return returnvalue + (player.mo.scale*5)
		else
			return returnvalue
		end
	end
end

//Get the player's input angle
local function inputangle(player)
	if P_GetPlayerControlDirection(player) == 0
	or player.mo.flags2 & MF2_TWOD or twodlevel
		return player.drawangle
	else 
		return player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove*FRACUNIT)
	end
end

//Spawn dust
local function skipdust(player, keepmom)
	if player.mo and player.mo.valid and player.mo.skin == "skip"
		for i = 1, 16 --taken from werehog with permission lol
			local dust = P_SpawnMobjFromMobj(player.mo, 0,0,0,
			player.mo.eflags & (MFE_UNDERWATER | MFE_TOUCHWATER) and MT_MEDIUMBUBBLE or MT_PARTICLE)
			dust.fuse = TICRATE/4
			dust.scale = player.mo.scale
			dust.scalespeed = FixedMul($, dust.scale)
			dust.destscale = player.mo.scale/8
			P_InstaThrust(dust, i*ANGLE_22h, 6*player.mo.scale)
			dust.momz = -2*P_MobjFlip(player.mo)*player.mo.scale
			dust.frame = $|TR_TRANS60
			
			if keepmom
				dust.momx = $ + player.mo.momx/keepmom
				dust.momy = $ + player.mo.momy/keepmom
				dust.momz = $ + player.mo.momz/keepmom
			end
		end
	end
end

//Spawns objects in a circle
local function skipcircle(mobj, mobjtype, ns, vertical, vertangle)
	local i = 0	while i < 8
		local fa = (i*(ANGLE_180/4))
		if mobjtype == MT_DUST and mobj.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER)
			mobjtype = MT_SMALLBUBBLE
		end
		local mo = P_SpawnMobj(mobj.x, mobj.y, mobj.z+(mobj.height/2), mobjtype)
		if mo and mo.valid
			mo.scale = mobj.scale
			if mobjtype == MT_DUST
				if mobj.player and
				((mobj.player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
				or (mobj.player.powers[pw_shield] & SH_NOSTACK) == SH_FLAMEAURA)
					mo.state = S_SPINDUST_FIRE1
				else
					mo.state = S_SPINDUST1
				end
			end
			if vertical
				mo.momz = FixedMul(sin(fa),ns)
				P_InstaThrust(mo, vertangle+ANGLE_90,
				FixedMul(cos(fa),ns))
			else
				fa = $ + vertangle or 0
				mo.momx = FixedMul(sin(fa),ns)
				mo.momy = FixedMul(cos(fa),ns)
			end
		end
		i = $+1
	end
end

//Spawn scrap metal
local function skipmetalscrap(target, source)
	if not (target and target.valid) return end
	local scrap = P_SpawnMobjFromMobj(target,0,0,0,MT_SKIPMETALSCRAP)
	if scrap and scrap.valid
		scrap.shadowscale = FRACUNIT/2
		scrap.reactiontime = scrap.scale
			
		//Change the color
		if target.color
			scrap.color = target.color
		elseif SkipBadnikColor[target.type]
			scrap.color = SkipBadnikColor[target.type]
		else
			scrap.color = SKINCOLOR_CLOUDY
		end
			
		scrap.cusval = scrap.color
			
		//Do the movement
		P_SetObjectMomZ(scrap, FRACUNIT*10, true)
		P_InstaThrust(scrap, FixedAngle(360*P_RandomFixed()), 10*P_RandomFixed())
		scrap.rollangle = FixedAngle(360*P_RandomFixed())
			
		//Big scraps
		if (P_RandomChance(FRACUNIT/3) or target.player) and not (target.player
		and target.player.skipscrap and target.player.skipscrap < 2)
			scrap.threshold = 2
			if P_RandomChance(FRACUNIT/3)
				scrap.scale = $*3/2
				scrap.shadowscale = $*2/3
				scrap.frame = 0
			elseif P_RandomChance(FRACUNIT/2)
				if target.type == MT_BLUECRAWLA or target.type == MT_REDCRAWLA
					scrap.frame = 7
				elseif target.type == MT_CRUSHSTACEAN or target.type == MT_BANPYURA
					scrap.frame = 8
				elseif target.type == MT_GSNAPPER or target.type == MT_SPINCUSHION
					scrap.frame = 9
				end
			else
				scrap.height = $*2
				scrap.radius = $*2
				scrap.shadowscale = $/2
				scrap.frame = P_RandomRange(5,6)
			end
			
		//Small scraps
		else
			scrap.threshold = 1
			scrap.scale = $*3/2
			scrap.shadowscale = $/2
			scrap.frame = P_RandomRange(1,4)
		end
		scrap.frame = $|FF_FULLBRIGHT
			
		if target.player and target.player.skipscrap
			target.player.skipscrap = max($-scrap.threshold,0)
			scrap.skiplessmagnetic = true
			if target.health
				P_InstaThrust(scrap, FixedAngle(360*P_RandomFixed()), 15*scrap.reactiontime)
			end
		end
		
		//If we're provided a target to home in on, set it
		if source and source.valid
			if source.player and (source.skin == "skip" or skipbuddy(source.player))
				scrap.target = source
			elseif source.self and source.self.owner and source.self.owner.valid
			and source.self.owner.mo and source.self.owner.mo.valid
			and (source.self.owner.mo.skin == "skip" or skipbuddy(source.self.owner))
				scrap.target = source.self.owner.mo
			end
		end
	end
end

//Spawn scrap metal when an enemy gets hurt
addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
	if target and target.valid and (target.flags&MF_ENEMY or target.flags&MF_BOSS)
	and source and source.valid and (source.player or source.self)
	
		//If Skip didn't kill an enemy, check if any other Skip players exist
		//If not, don't spawn the scrap
		if source.skin != "skip"
			local skip = false
			for player in players.iterate
				if player.mo and player.mo.valid
				and (player.mo.skin == "skip" or skipbuddy(player))
					skip = true
				end
			end
			if not skip return end
		end
		
		//Get back your jump abilities when you hit an enemy with the homing dive
		if source.skin == "skip" and source.player and source.player.pflags & PF_SHIELDABILITY
		and (source.player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT
		and source.skipdove and not P_IsObjectOnGround(source)
			source.player.pflags = $|PF_JUMPED&~PF_THOKKED&~PF_SHIELDABILITY&~PF_DRILLING
			source.skipdove = false
			source.state = S_PLAY_SKIPCANCEL
			P_SetObjectMomZ(source, 10*FRACUNIT, false)
		end
	
		local amount = 3
		if target.health <= 1
			amount = max(min(target.info.spawnhealth*3, 8),1)
			if SkipBadnikScrap[target.type] == 0
				return
			elseif SkipBadnikScrap[target.type]
				amount = $ + SkipBadnikScrap[target.type]
			end
		end
		for i = 1, amount
			skipmetalscrap(target, source)
		end
	end
end)

//Ring Boxes give you scrap
addHook("MobjDeath", function(target, inflictor, source, damage, damagetype)
	if target and target.valid and source and source.valid
	and source.player and (source.skin == "skip" or skipbuddy(source.player))
		for i = 1, 9
			skipmetalscrap(target, source)
		end
	end
end, MT_RING_BOX)

//Lose 10 scrap metal when you die
addHook("MobjDeath", function(target, inflictor, source, damage, damagetype)
	if target and target.valid and target.player and target.player.skipscrap
	and not G_IsSpecialStage() and not (target.player.pflags&PF_FINISHED)
	and (target.skin == "skip" or skipbuddy(target.player))
		S_StartSoundAtVolume(target, sfx_kc46, 96, target.player)
		for i = 1, 5
			if target.player.skipscrap
				skipmetalscrap(target)
			end
		end
	end
end, MT_PLAYER)

//Lose 4 scrap when you get hit
addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
	if target and target.valid and target.player and target.player.skipscrap
	and (target.skin == "skip" or skipbuddy(target.player))
	and target.player.rings and not target.player.powers[pw_shield]
	and not G_IsSpecialStage() and not (target.player.pflags&PF_FINISHED)
	and not (damagetype&DMG_INSTAKILL)
		for i = 1,2
			if target.player.skipscrap
				skipmetalscrap(target)
			end
		end
	end
end, MT_PLAYER)

//Collecting the Scrap Metal
addHook("TouchSpecial", function(special, toucher)
	if special and special.valid and toucher and toucher.valid and toucher.player
		if special.tics > TICRATE*19/2
		or not (toucher.skin == "skip" or skipbuddy(toucher.player))
			return true
		end

		if toucher.player.skipscrap == nil
			toucher.player.skipscrap = 0
		end
		
		toucher.player.skipscrap = $+special.threshold
		
		if special.threshold > 1
			S_StartSoundAtVolume(toucher, sfx_skpms2, 192)
		else
			S_StartSoundAtVolume(toucher, sfx_skpms1, 192)
		end
		
		special.flags2 = $&~MF2_DONTDRAW
		special.flags = MF_NOCLIP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT|MF_NOGRAVITY
		P_InstaThrust(special,0,0)
		special.scalespeed = $/2
		special.destscale = special.scale/2
		special.momz = 0
		special.shadowscale = 0
		special.reactiontime = 0
		special.tracer = toucher
		special.color = special.cusval
		special.colorized = false
		special.tics = -1
		special.fuse = TICRATE/2
		
		return true
	end
end, MT_SKIPMETALSCRAP)

//Scrap Metal Thinker
addHook("MobjThinker", function(mobj)
	if mobj.fuse and mobj.tracer and mobj.tracer.valid
		mobj.reactiontime = $+((mobj.fuse-(TICRATE/4))*(mobj.tracer.scale*5/4))
		P_MoveOrigin(mobj, P_ReturnThrustX(nil, mobj.tracer.player.drawangle+ANGLE_180, mobj.tracer.radius/2)+mobj.tracer.x,
		P_ReturnThrustY(nil, mobj.tracer.player.drawangle+ANGLE_180, mobj.tracer.radius/2)+mobj.tracer.y,
		mobj.tracer.z+(mobj.tracer.height/2)-(mobj.tracer.height/3*P_MobjFlip(mobj.tracer))
		+(mobj.reactiontime*P_MobjFlip(mobj.tracer)))
	elseif mobj.sprite == SPR_SKRP and mobj.tics > 0
		if not P_IsObjectOnGround(mobj) and not (mobj.eflags & MFE_JUSTHITFLOOR)
			mobj.rollangle = $+ANGLE_11hh
			if (leveltime%2)
				P_SpawnGhostMobj(mobj)
			end
		end
		
		//Flashing white
		if (leveltime%(TICRATE/2))
			mobj.color = mobj.cusval
			mobj.colorized = false
		elseif mobj.tics > TICRATE*2
			mobj.color = SKINCOLOR_SUPERSILVER1
			mobj.colorized = true
		end
		
		//Flashing when about to despawn
		if mobj.tics <= TICRATE
			if (leveltime%2)
				mobj.flags2 = $|MF2_DONTDRAW
			else
				mobj.flags2 = $&~MF2_DONTDRAW
			end
		elseif mobj.tics <= TICRATE*2
			if (leveltime%4)
				mobj.flags2 = $|MF2_DONTDRAW
			else
				mobj.flags2 = $&~MF2_DONTDRAW
			end
		end
		
		//Attraction
		if mobj.tics <= TICRATE*19/2
			if mobj.target and mobj.target.valid and mobj.target.player
			and (mobj.target.skin == "skip" or skipbuddy(mobj.target.player))
			and not P_PlayerInPain(mobj.target.player)
			and P_CheckSight(mobj, mobj.target)
				P_HomingAttack(mobj, mobj.target)
			elseif leveltime%2
				local distance = RING_DIST
				if mobj.skiplessmagnetic
					distance = $/2
				end
				for player in players.iterate
					if player.mo and player.mo.valid and player.mo.health
					and (player.mo.skin == "skip" or skipbuddy(player))
					and not P_PlayerInPain(player)
					and P_CheckSight(mobj, player.mo)
					and P_AproxDistance(player.mo.x-mobj.x, player.mo.y-mobj.y) < distance
						distance = P_AproxDistance(player.mo.x-mobj.x, player.mo.y-mobj.y)
						mobj.target = player.mo
					end
				end
			end
		end
	end
end, MT_SKIPMETALSCRAP)

//Reset its scale when it poofs
addHook("MobjFuse", function(mobj)
	if mobj.tracer and mobj.tracer.valid
		S_StartSoundAtVolume(mobj.tracer, sfx_cdfm66, 96)
		mobj.scale = mobj.tracer.scale
		mobj.rollangle = 0
	end
end, MT_SKIPMETALSCRAP)

//Ray Cast thinker
addHook("MobjThinker", function(mobj)
	if not mobj.threshold
		mobj.threshold = 1
		mobj.fuse = TICRATE/2
	end
	if mobj.subsector and mobj.subsector.valid
	and mobj.subsector.sector and mobj.subsector.sector.valid
		if mobj.subsector.sector.lightlevel < 170
			P_SpawnLightningFlash(mobj.subsector.sector)
			mobj.subsector.sector.lightlevel = 170
		end
		for fof in mobj.subsector.sector.ffloors()
			if fof.valid and (fof.flags & FF_EXISTS)
			and (fof.bottomheight >= mobj.z
			or (mobj.z < fof.topheight
			and mobj.z+mobj.height > fof.bottomheight))
			and fof.sector.valid and fof.sector.lightlevel < 170
			P_SpawnLightningFlash(fof.sector)
			fof.sector.lightlevel = 170
			end
		end
	end
end, MT_SKIPRAYCAST)

//Start a Dive
addHook("SpinSpecial", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "skip"
		//Cancel the menu by pressing spin
		if player.mo.skipmenu and not (player.pflags & PF_SPINDOWN)
			S_StartSound(player.mo, sfx_cdfm23, player)
			player.mo.skipmenu = false
		end
		
		if P_PlayerInPain(player)
		or (player.pflags & PF_SLIDING)
		or player.powers[pw_carry] != CR_NONE
		or player.spectator
		or player.playerstate != PST_LIVE
		or not player.mo.health
		or (player.panim == PA_PAIN and not (player.pflags & PF_JUMPED))
		or player.powers[pw_super] == 1
		or player.iseggrobo
		or player.powers[pw_nocontrol]
		or player.mo.skipdove
		or player.exiting
		or player.mo.skipdivehit
		or player.mo.skipcrouching
		or player.mo.skipsteam
		or player.pflags & (PF_SPINDOWN|PF_STASIS)
		or P_SuperReady(player)
		//or (player.cmd.buttons & BT_JUMP and not (player.pflags & PF_JUMPDOWN))
		or player.secondjump == 69
		or (ESPLoaded and player.powers[pw_shield] == SH_CLOCK and player.pflags&PF_JUMPED
		and not P_IsObjectOnGround(player.mo) and not (player.pflags&PF_THOKKED))
		or (P_IsObjectOnGround(player.mo) and P_GetPlayerControlDirection(player) == 0
		and not (player.pflags & PF_SPINNING))
		return end
		
		local oldpanim = player.panim
		if player.cmd.buttons & BT_JUMP
			player.pflags = $ | PF_JUMPDOWN
		end
		
		//Slide Recovery
		if player.pflags & PF_SPINNING and P_IsObjectOnGround(player.mo)
		and (player.mo.state == S_PLAY_SKIPSLIDE or player.mo.state == S_PLAY_SKIPTRANSITION)
			player.mo.state = S_PLAY_SKIPCANCEL
			player.pflags = $&~PF_DRILLING
			player.mo.skipdove = false
			player.secondjump = 0
			S_StartSound(player.mo,sfx_s3k9a)
			
			if player.mo.skipperfectwindow
				//The dive aims in the direction you're facing in Simple
				P_InstaThrust(player.mo, player.mo.angle, skipdive(player))
				player.drawangle = player.mo.angle

				skipdust(player)
				S_StartSoundAtVolume(player.mo, sfx_s3k81, 128)
				skipcircle(player.mo, MT_DUST, 4*player.mo.scale, false, player.drawangle)
			end
		
		//Charge Dive
		elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_ARMAGEDDON
		and not P_IsObjectOnGround(player.mo)
			player.mo.state = S_PLAY_ROLL
			player.mo.chargedive = TICRATE*2
			S_StartSoundAtVolume(player.mo, sfx_skpchg, 196)
			player.pflags = $|PF_DRILLING
			player.mo.skipdove = true
			
		//Normal Dive
		else
			player.mo.state = S_PLAY_SKIPALTDIVE
				
			//The dive aims in the direction you're facing in Simple
			P_InstaThrust(player.mo, player.mo.angle, skipdive(player))
			player.drawangle = player.mo.angle
			
			if player.mysticsuper -- Mystic Super dive?
				P_SpawnGhostMobj(player.mo)
				if (player.powers[pw_shield] > 1) or not (player.secondjump)
					player.pflags = $|PF_DRILLING --"Normal first dive"
					player.mo.skipdove = true
				elseif player.secondjump
					player.secondjump = 899
					player.mo.skipdove = false
				end
			else
				player.pflags = $|PF_DRILLING
				player.mo.skipdove = true
			end
			S_StartSound(player.mo,sfx_s3k98)
			skipcircle(player.mo, MT_DUST, 4*player.mo.scale, true, player.drawangle)
		end
		
		//Let the fall switch do its thing
		if PlusLoaded and player.powers[pw_shield] == SH_BUMPERSHIELD
		and not P_IsObjectOnGround(player.mo)
			if (player.pflags&PF_THOKKED)
				player.pflags = $|PF_SHIELDABILITY
				S_StartSound(mobj, sfx_s3kaa)
				player.mo.momz = -$
			end
		
		//The Charge dive sets your vertical momentum to zero
		elseif player.mo.chargedive
			player.mo.momz = 0
			
		//Dives on the ground and after double jumps have less vertical power
		elseif P_IsObjectOnGround(player.mo) or player.secondjump
			if player.mysticsuper and not (player.powers[pw_shield] > 1)
			and not P_IsObjectOnGround(player.mo)
				P_SetObjectMomZ(player.mo, -FRACUNIT, true) --Infinite dives, but no infinite height!
			elseif oldpanim != PA_IDLE and oldpanim != PA_WALK
				if player.mo.eflags&MFE_UNDERWATER
					P_SetObjectMomZ(player.mo, (player.jumpfactor*(39/4)/4), false)
				else
					P_SetObjectMomZ(player.mo, (player.jumpfactor*(39/4)/2), false)
				end
			end
		elseif player.mo.eflags&MFE_UNDERWATER
			P_SetObjectMomZ(player.mo, (player.jumpfactor*(39/4)/2), false)
		else
			P_SetObjectMomZ(player.mo, player.jumpfactor*(39/4), false)
		end
		
		//Shield Abilities
		//Flame Shield/Burst Dive is handled within the skipdive function
		//The Armageddon Shield/Charge Dive is handled shortly before this
		if player.mo.state == S_PLAY_SKIPALTDIVE
			//High Dive
			if (player.powers[pw_shield] & SH_NOSTACK) == SH_WHIRLWIND
			and not P_IsObjectOnGround(player.mo) and not player.secondjump
				S_StartSound(player.mo, sfx_wdjump)
				player.mo.momz = $*3/2
				
			//Homing Dive
			elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT
				local lockonshield = P_LookForEnemies(player, false, false)
				player.mo.tracer = lockonshield
				player.mo.target = lockonshield
				if lockonshield and lockonshield.valid
					player.pflags = $|PF_SHIELDABILITY
					player.mo.angle = R_PointToAngle2(player.mo.x, player.mo.y, lockonshield.x, lockonshield.y)
					S_StartSound(player.mo, sfx_s3k40)
					player.homing = 3*TICRATE
				end
				
			//Bounce Dive
			elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
			and not P_IsObjectOnGround(player.mo)
				player.pflags = $|PF_SHIELDABILITY
				player.secondjump = 0
				S_StartSound(player.mo, sfx_s3k44)
				P_SetObjectMomZ(player.mo, -24*FRACUNIT, false)
			
			//Meteor Dive
			elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
			and not P_IsObjectOnGround(player.mo)
				P_SetObjectMomZ(player.mo, -24*FRACUNIT, false)
				
			//Wire Dive
			elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_THUNDERCOIN
			and not P_IsObjectOnGround(player.mo)
				if not player.powers[pw_super]
					player.pflags = $|PF_SHIELDABILITY
				end
				player.mo.momz = 0
				player.mo.skipwiredivedir = player.drawangle
				P_InstaThrust(player.mo, player.mo.skipwiredivedir, 60*player.mo.scale)
				player.mo.skipwiredive = TICRATE*3/2
				P_NukeEnemies(player.mo, player.mo, 0) //Purely for visual effect
				P_RadiusAttack(player.mo, player.mo, RING_DIST, DMG_ELECTRIC)
				S_StartSound(player.mo, sfx_s3k45)
			
			//Lightdash Dive (for diving after a double jump)
			elseif ESPLoaded and player.powers[pw_shield] == SH_STAR
			and not P_IsObjectOnGround(player.mo)
			and (player.pflags&PF_THOKKED or player.powers[pw_super])
				player.mo.starlightdash = 1
				player.mo.star_timer = 0
				player.pflags = $|PF_THOKKED|PF_SHIELDABILITY
				
			//Gravflip Dive (for diving after a double jump)
			elseif ESPLoaded and player.powers[pw_shield] == SH_GRAVITY
			and not P_IsObjectOnGround(player.mo)
			and (player.pflags&PF_THOKKED or player.powers[pw_super])
				if player.mo.flags2 & MF2_OBJECTFLIP
					player.mo.flags2 = $&~MF2_OBJECTFLIP
				else
					player.mo.flags2 = $|MF2_OBJECTFLIP
				end
				S_StartSound(player.mo, sfx_peww)
				player.pflags = $|PF_THOKKED|PF_SHIELDABILITY
				player.mo.momz = -$
				
			//Super Bubblegum
			elseif ESPLoaded and player.powers[pw_shield] == SH_GUM
			and not P_IsObjectOnGround(player.mo) and player.powers[pw_super]
				S_StartSound(player.mo, sfx_s3k8a)
				local bubb = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_GUM_BUBBLE)
				bubb.target = player.mo
				player.pflags = $ & ~PF_STARTJUMP & ~PF_JUMPED & ~PF_SPINNING
				player.pflags = $ | PF_THOKKED
				
			//Super Clock
			elseif ESPLoaded and player.powers[pw_shield] == SH_CLOCK
			and not P_IsObjectOnGround(player.mo) and player.powers[pw_super]
			and player.mo.rewindpoint
				S_StartSound(player.mo, sfx_kc31)
				P_FlashPal(player,PAL_WHITE,10)
				P_MoveOrigin(player.mo,
					player.mo.rewindpoint.x,
					player.mo.rewindpoint.y,
					player.mo.rewindpoint.z)
				A_ForceStop(player.mo)
				player.mo.angle = player.mo.rewindpoint.angle
				P_ResetPlayer(player)
				player.powers[pw_nocontrol] = 17
				player.pflags = $ | PF_THOKKED | PF_SHIELDABILITY
			end
		end
		
		//Make the slide usable for rising Spindashable platforms
		if P_IsObjectOnGround(player.mo)
			local sectorthing = player.mo.subsector and player.mo.subsector.sector
			if sectorthing and sectorthing.valid then
				for fof in sectorthing.ffloors()
					if fof.valid and (abs(fof.topheight - player.mo.z) <= 40*player.mo.scale
					or abs(fof.bottomheight - player.mo.z+player.mo.height) <= 40*player.mo.scale)
					and fof.master and fof.master.valid and fof.master.flags&ML_NOCLIMB
					and (fof.master.special == 153 or fof.master.special == 180
					or (fof.master.special >= 150 and fof.master.special <= 152)
					or (fof.master.special >= 190 and fof.master.special <= 195)
					or fof.master.special == 176 or fof.master.special == 177)
						P_InstaThrust(player.mo,0,0)
						return
					end
				end
			end
		end
		
		player.pflags = $|PF_JUMPED|PF_NOJUMPDAMAGE&~PF_STARTJUMP&~PF_SPINNING
	end
end)

//Slide recovery but for the Jump button
addHook("JumpSpecial", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "skip"
		//No jumping while crouching or crafting
		//Not using PF_JUMPSTASIS since that makes you jump if you hold the button
		if player.mo.skipcrouching or player.mo.skipmenu return true end
	
		//Allow double jumps out of shields
		if player.pflags&PF_SHIELDABILITY and player.pflags&PF_JUMPED
		and not player.secondjump and not (player.pflags&PF_JUMPDOWN)
		and ((player.powers[pw_shield] & SH_NOSTACK) != SH_BUBBLEWRAP
		or not (player.pflags&PF_THOKKED))
			player.pflags = $&~PF_SHIELDABILITY&~PF_THOKKED
		end
		
		if (P_PlayerInPain(player)
		or (player.pflags & PF_SLIDING)
		or player.powers[pw_carry] != CR_NONE
		or player.spectator
		or player.playerstate != PST_LIVE
		or not player.mo.health
		or (player.panim == PA_PAIN and not (player.pflags & PF_JUMPED))
		or player.powers[pw_super] == 1
		or player.iseggrobo
		or player.powers[pw_nocontrol]
		or player.mo.skipdove
		or player.exiting
		or player.mo.skipdivehit
		or player.mo.skipcrouching
		or player.mo.skipsteam
		or player.pflags & PF_JUMPDOWN
		or player.secondjump == 69
		or (P_IsObjectOnGround(player.mo) and P_GetPlayerControlDirection(player) == 0
		and not (player.pflags & PF_SPINNING)))
		and not (player.mo.skipdove and player.mo.eflags & MFE_JUSTHITFLOOR
		and not (player.pflags & PF_JUMPDOWN))
		return end
		
		//Ledge grab jump
		if player.climbing
			player.climbing = 0
			player.charability = skins[player.skin].ability
			player.camerascale = skins[player.skin].camerascale
			
			//We're gonna do what's called a pro gamer move
			player.pflags = $ &~ PF_JUMPED
			player.mo.state = S_PLAY_SKIPCANCEL
			player.panim = PA_DASH
			player.powers[pw_nocontrol] = player.mo.tics
			
			local ghost = P_SpawnGhostMobj(player.mo)
			player.mo.z = $ + player.mo.height*P_MobjFlip(player.mo)/2
			P_TryMove(player.mo, player.mo.x + P_ReturnThrustX(nil, player.mo.angle, player.mo.radius),
			player.mo.y + P_ReturnThrustY(nil, player.mo.angle, player.mo.radius), true)
			
			S_StartSound(player.mo, sfx_s3k9a)
			return true
		end
		
		//Slide Recovery
		if player.pflags & PF_SPINNING and P_IsObjectOnGround(player.mo)
		and (player.mo.state == S_PLAY_SKIPSLIDE or player.mo.state == S_PLAY_SKIPTRANSITION)
		or (player.mo.skipdove and player.mo.eflags & MFE_JUSTHITFLOOR
		and not (player.pflags & PF_JUMPDOWN))
			player.mo.state = S_PLAY_SKIPCANCEL
			player.secondjump = 0
			S_StartSound(player.mo, sfx_s3k9a)
			
			if player.mo.skipperfectwindow
			or (player.mo.skipdove and player.mo.eflags & MFE_JUSTHITFLOOR
			and not (player.pflags & PF_JUMPDOWN))
				//The dive aims in the direction you're facing in Simple
				P_InstaThrust(player.mo, player.mo.angle, skipdive(player))
				player.drawangle = player.mo.angle
				
				skipdust(player)
				S_StartSoundAtVolume(player.mo, sfx_s3k81, 128)
				skipcircle(player.mo, MT_DUST, 4*player.mo.scale, false, player.drawangle)
				if player == displayplayer or player == secondarydisplayplayer
					P_StartQuake(10*player.mo.scale, 1)
				end
			end
			
			if player.mo.eflags&MFE_UNDERWATER
				P_SetObjectMomZ(player.mo, (player.jumpfactor*(39/4)/4), false)
			else
				P_SetObjectMomZ(player.mo, (player.jumpfactor*(39/4)/2), false)
			end
			
			player.pflags = $|PF_JUMPED|PF_NOJUMPDAMAGE&~PF_STARTJUMP&~PF_SPINNING&~PF_DRILLING
			player.mo.skipdove = false
			
			return true
		end
	end
end)

//Double Jump and Dive Cancel
//CA_DOUBLEJUMP is for nerds
addHook("AbilitySpecial", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "skip"
		if (player.mysticsuper and player.secondjump > 898)
			return true
		end
		if not (player.pflags & PF_THOKKED) or player.mo.chargedive
		or (player.secondjump < 2 and player.mo.skipwiredive)
			player.pflags = $ & ~PF_JUMPED
			P_DoJump(player, false)
			player.pflags = $|PF_THOKKED
			if player.mo.skipdove
				player.mo.state = S_PLAY_SKIPCANCEL
			else
				player.mo.state = S_PLAY_SKIPDOUBLEJUMP
			end
			skipdust(player)
			player.mo.skipdove = false
			player.pflags = $&~PF_DRILLING
			if player.mo.chargedive
				local i=0 while i<10 S_StopSound(player.mo) i=$+1 end
				player.mo.chargedive = 0
				player.mo.momz = $/2
				if player.secondjump
					player.secondjump = 69
				else
					player.secondjump = $+1
				end
			else
				player.secondjump = $+1
			end
			S_StartSound(player.mo, mariomode and sfx_skpdbm or sfx_skpdbl)
		end
		return true
	end
end)

//Prevent Bonking on monitors when you slide into them
//Uses the monitor breaking code from the source code
addHook("MobjMoveCollide", function(tmthing, thing)
	if tmthing and tmthing.valid and tmthing.player and tmthing.skin == "skip"
	and (tmthing.skipdove or tmthing.state == S_PLAY_SKIPSLIDE or tmthing.state == S_PLAY_SKIPTRANSITION)
	and not tmthing.skipdivehit and thing and thing.valid and thing.health
	and thing.flags&MF_MONITOR and not (thing.flags&MF_GRENADEBOUNCE)
	and not ((thing.type == MT_RING_REDBOX and tmthing.player.ctfteam != 1) or (thing.type == MT_RING_BLUEBOX and tmthing.player.ctfteam != 2))
	and (not (thing.flags & MF_SOLID) or P_PlayerCanDamage(tmthing.player, thing))
		if (thing.z - thing.scale <= tmthing.z + tmthing.height
		and thing.z + thing.height + thing.scale >= tmthing.z)
			local player = tmthing.player
			local flipval = P_MobjFlip(thing) // Save this value in case monitor gets removed.
			// Going down? Then bounce back up.
			if P_DamageMobj(thing, tmthing, tmthing, 1, 0) // break the monitor
			and flipval*(player.mo.momz) < 0 // monitor is on the floor and you're going down, or on the ceiling and you're going up
			and not ((player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
			and player.pflags&PF_SHIELDABILITY) // you're not piercing through the monitor...
				if (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
				and player.pflags&PF_SHIELDABILITY
					P_DoBubbleBounce(player)
				else
					player.mo.momz = $*-1 // Therefore, you should be thrust in the opposite direction, vertically.
				end
			end
			player.mo.z = $-player.mo.momz // to ensure proper collision.
			return false
		end
	end
end, MT_PLAYER)

//Allow Double Jumping off THZ steam
addHook("MobjMoveCollide", function(tmthing, thing)
	if tmthing and tmthing.valid and tmthing.player and tmthing.skin == "skip"
	and thing and thing.valid and thing.type == MT_STEAM
	and (thing.z - thing.scale <= tmthing.z + tmthing.height
	and thing.z + thing.height + thing.scale >= tmthing.z)
		tmthing.skipsteam = true
	end
end, MT_PLAYER)

//Same for those dumb fans
addHook("MobjMoveCollide", function(tmthing, thing)
	if tmthing and tmthing.valid and tmthing.player and tmthing.skin == "skip"
	and thing and thing.valid and thing.type == MT_FAN
	and tmthing.z - thing.z <= thing.health << FRACBITS
		tmthing.skipsteam = true
	end
end, MT_PLAYER)

//Bonking into walls while diving or sliding
addHook("MobjMoveBlocked", function(mo, mobj, collideline)
	if not (mo and mo.player and mo.skin == "skip") then return end
	local player = mo.player
	
	if (mo.skipdove or mo.state == S_PLAY_SKIPSLIDE or mo.state == S_PLAY_SKIPTRANSITION)
	and not mo.skipdivehit and not mo.readyforbonk
	and mo.ceilingz - mo.floorz >= FixedMul(skins[mo.skin].height, mo.scale)
		mo.readyforbonk = player.speed -- Save the player's speed value. Use it in the playerthink. 
		mo.readyforbonkx = mo.momx --Just CTRL+F "Bonk Code" to find the continuation of this.
		mo.readyforbonky = mo.momy
	
	//Ledge Grabbing (Yes this is a Mario copy-paste job, but I can use my own code how I want!)
	elseif not P_IsObjectOnGround(mo) and not player.powers[pw_carry]
	and not mo.skipdove and not mo.skipdivehit and not mo.readyforbonk
	and (player.cmd.forwardmove or player.cmd.sidemove) and not player.climbing
	and ( (player.pflags&PF_STARTJUMP and mo.momz*P_MobjFlip(mo) <= 0)
	or (not (player.pflags&PF_STARTJUMP) and mo.momz*P_MobjFlip(mo) <= -4*P_GetMobjGravity(mo)))
	and not (player.pflags & (PF_JUMPSTASIS|PF_SPINNING))
		local prevline = player.lastlinehit
		local prevside = player.lastsidehit
		
		player.lastlinehit = -1
		player.lastsidehit = -1
		
		P_SlideMove(mo)
		player.powers[pw_pushing] = 3
		
		local line = lines[player.lastlinehit]
		if not line and collideline
			line = collideline
			player.lastlinehit = #line
			player.lastsidehit = line.sidenum[P_PointOnLineSide(mo.x, mo.y, line)]
		end
		local side = sides[player.lastsidehit]
		if line and line.valid and side and side.valid
			local pointx, pointy = P_ClosestPointOnLine(mo.x, mo.y, line)
			local angle = R_PointToAngle2(mo.x, mo.y, pointx, pointy)
			
			local diff = inputangle(player) - angle
			diff = InvAngle(InvAngle($))
			
			if abs(diff) < ANGLE_90
			and not (line and line.backsector
			and line.backsector.ceilingpic == "F_SKY1"
			and line.frontsector
			and line.frontsector.ceilingpic == "F_SKY1"
			and (mo.z >= line.frontsector.ceilingheight
			or mo.z >= line.backsector.ceilingheight))
			and line.special != 41
				//Can we ledge grab?
				local grabbable = false
				
				//Get the side we're NOT on
				local grabside = side
				if line.frontside == side
					grabside = line.backside
				else
					grabside = line.frontside
				end
				
				//Get the sector we're grabbing onto...
				local sector = grabside and grabside.valid and grabside.sector
				if sector and sector.valid
				and sector.ceilingheight - sector.floorheight >= mo.height
				//and not (GetSecSpecial(sector.special, 1) and GetSecSpecial(sector.special, 1) <= 8)
					local thok = P_SpawnMobjFromMobj(mo,0,0,FixedDiv(mo.height, mo.scale)/2,MT_THOK)
					if thok and thok.valid
						thok.flags = $ &~ MF_NOCLIP &~ MF_NOCLIPTHING &~ MF_NOCLIPHEIGHT
						thok.tics = 1
						P_MoveOrigin(thok, thok.x + P_ReturnThrustX(nil, angle, mo.scale),
						thok.y + P_ReturnThrustY(nil, angle, mo.scale), thok.z)
						
						local floor = thok.floorz
						local ceiling = thok.ceilingz
						
						//Are we in grab range?
						if ceiling - floor < mo.height
							grabbable = false
						elseif mo.eflags & MFE_VERTICALFLIP
							if mo.z - mo.height/2 < ceiling
							and mo.z + mo.height > ceiling
							and mo.z + mo.height < mo.ceilingz - mo.height*2/3
							and mo.z - mo.height > mo.floorz
							and not sector.c_slope
								mo.z = ceiling
								grabbable = true
							end
						elseif mo.z < floor
						and mo.z + mo.height*3/2 > floor
						and mo.z > mo.floorz + mo.height*2/3
						and mo.z + mo.height*2 < mo.ceilingz
						and not sector.f_slope
							mo.z = floor - mo.height
							grabbable = true
						end
						
						//Set mo.angle without changing the player's camera
						if grabbable
							local target = mo.target
							mo.target = thok
							A_FaceTarget(mo)
							mo.target = target
						end
					end
				end
				
				//Refresh
				player.glidetime = 0
				
				//Ledge Grab
				if grabbable
					player.drawangle = angle
					player.climbing = 5
					
					player.charability = CA_GLIDEANDCLIMB
					player.camerascale = skins[player.skin].camerascale/2
					player.pflags = $|PF_FULLSTASIS
					
					A_ForceStop(mo)
					S_StartSound(mo, sfx_s3k4a)
					
				//Wall Slide
				else
					player.lastlinehit = prevline
					player.lastsidehit = prevside
				end
			end
		else
			player.lastlinehit = prevline
			player.lastsidehit = prevside
		end
		return true
	end
end, MT_PLAYER)

//For the Smug Dance
//...even though it doesn't seem like it does anything
addHook("ShouldJingleContinue", function(player, musname)
	if musname != "smugdance" return end
	if player and player.mo and player.mo.skin == "skip" and player.skipsmug
		return true
	else
		return false
	end
end)

//Ducking
local function SkipDuck(player)
	if player.mo and player.mo.valid and player.mo.skin == "skip"
		if player.climbing
			return P_GetPlayerHeight(player)*2
		elseif player.mo.skipcrouching
		or player.mo.state == S_PLAY_SKIPSLIDE
		or player.mo.state == S_PLAY_SKIPTRANSITION
			return P_GetPlayerSpinHeight(player)
		end
	end
end
addHook("PlayerHeight", SkipDuck)
addHook("PlayerCanEnterSpinGaps", SkipDuck)

//Main Thinker	
addHook("PlayerThink", function(player)
	//Remember what shield you have so that when you change levels you keep it
	if player.skipshield != (player.powers[pw_shield] & SH_NOSTACK)
	and not G_IsSpecialStage()
		player.skipshield = (player.powers[pw_shield] & SH_NOSTACK)
	end
	
	//Skip super override
	if player.skipsuper and not player.powers[pw_super]
		player.skipsuper = false
		player.charflags = ($ &~ SF_SUPER) | (skins[player.skin].flags & SF_SUPER)
		P_RestoreMusic(player)
		
		P_SpawnShieldOrb(player)
		skipreloadcustomshield(player)
	end
	
	//Driving effect
	if player.mo and player.mo.boat and not (leveltime % 7)
	and (player.mo.skin == "skip" or player.mo.skin == "jana")
		skipdust(player, 2)
	end
		
	if player.mo and player.mo.valid and player.mo.skin == "skip"
		
		//Crafting Menu Movement
		if player.skipyoffset == nil
			player.skipyoffset = 0
		elseif player.mo.skipmenu
			if player.skipyoffset < 14
				player.skipyoffset = $+1
			end
		elseif player.skipyoffset
			player.skipyoffset = $-1
		end
		
		//Make it so you can double jump off steam
		if player.mo.skipsteam
			resetskip(player)
			if not P_IsObjectOnGround(player.mo)
				player.secondjump = 0
				player.pflags = $|PF_JUMPED&~PF_THOKKED
			end
		end
		
		//Tap right
		if player.cmd.sidemove < 25 then
			player.righttapready = true
			player.righttapping = false
		elseif player.righttapready then
			player.righttapping = true
			player.righttapready = false
		else
			player.righttapping = false
		end
		
		//Tap left
		if player.cmd.sidemove > -25 then
			player.lefttapready = true
			player.lefttapping = false
		elseif player.lefttapready then
			player.lefttapping = true
			player.lefttapready = false
		else
			player.lefttapping = false
		end
		
		//Tap Jump
		if not (player.cmd.buttons & BT_JUMP) then
			player.jumptapready = true
			player.jumptapping = false
		elseif player.jumptapready then
			player.jumptapping = true
			player.jumptapready = false
		else
			player.jumptapping = false
		end
		
		//Tap Spin
		if not (player.cmd.buttons & BT_SPIN) then
			player.spintapready = true
			player.spintapping = false
		elseif player.spintapready then
			player.spintapping = true
			player.spintapready = false
		else
			player.spintapping = false
		end
		
		//Detect if we're tapping Custom 1
		if not (player.cmd.buttons & BT_CUSTOM1) then
			player.customtapready = true
			player.customtapping = false
		elseif player.customtapready then
			player.customtapping = true
			player.customtapready = false
		else
			player.customtapping = false
		end
		
		//Detect when we press Toss Flag
		if not (player.cmd.buttons & BT_TOSSFLAG)
			player.skiptosstapready = true
			player.skiptosstapping = false
		elseif player.skiptosstapready 
		and not (player.hugging) then
			player.skiptosstapping = true
			player.skiptosstapready = false
		else
			player.skiptosstapping = false
		end
		
		//Flashlight Toggle
		if player.skiplighton
			if player.customtapping
				player.skiplighton = false
			end
		elseif player.customtapping
			player.skiplighton = true
		end
		
		//Flashlight
		if not P_PlayerInPain(player) and player.panim != PA_PAIN
		and not player.mo.skipdivehit and player.mo.health
		and player.skiplighton
			if (player.skipflashlight and player.skipflashlight.valid)
				P_SPMAngle(player.mo, MT_SKIPRAYCAST, player.drawangle, 0)
			else
				S_StartSoundAtVolume(player.mo, sfx_skpflg, 128)
				player.skipflashlight = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_SKIPFLASHLIGHT)
				player.skipflashlight.target = player.mo
				player.skipflashlight.color = SKINCOLOR_WHITE
				player.skipflashlight.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
				player.skipflashlight.blendmode = AST_ADD
			end
		elseif player.skipflashlight and player.skipflashlight.valid
			if not player.skiplighton
				S_StartSoundAtVolume(player.mo, sfx_skpflg, 128)
			end
			P_KillMobj(player.skipflashlight)
		end
		
		//Jump Squat
		//Why not
		if player.mo.skipsquat
			if player.panim != PA_JUMP
				player.mo.skipsquat = false
			end
		elseif player.mo.state == S_PLAY_JUMP and player.pflags & PF_STARTJUMP
		and not player.secondjump
			player.mo.skipsquat = true
			player.mo.state = S_PLAY_SKIPJUMP
			player.panim = PA_JUMP
			player.mo.frame = ($ &~ FF_FRAMEMASK) | 2
		end
		
		//Running SFX code
		//Since Starfy likely isn't gonna see the light of day, might as well
		if player.mo.sprite2 & FF_SPR2SUPER
			player.canrunsfx = false
		elseif player.canrunsfx and player.panim == PA_RUN and P_IsObjectOnGround(player.mo)
		and (player.mo.frame == 1 or player.mo.frame == 3
		or player.mo.frame&FF_FRAMEMASK == 1 or player.mo.frame&FF_FRAMEMASK == 3)
			S_StartSoundAtVolume(player.mo, sfx_sfstep, 128)
			player.canrunsfx = false
		elseif player.panim == PA_RUN and not player.canrunsfx
		and (player.mo.frame == 0 or player.mo.frame == 2
		or player.mo.frame&FF_FRAMEMASK == 0 or player.mo.frame&FF_FRAMEMASK == 2)
			player.canrunsfx = true
		end
		
		//Running particles
		if player.mo.sprite2 & FF_SPR2SUPER and not (leveltime % 4)
		and player.panim == PA_RUN and P_IsObjectOnGround(player.mo)
			local angle = R_PointToAngle2(0,0,player.mo.momx,player.mo.momy)
			for i = 0, 4
				local dust = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_DUST)
				if dust and dust.valid
					dust.flags = $|MF_NOCLIPTHING&~MF_NOCLIP&~MF_SCENERY|MF_BOUNCE
					dust.angle = angle
					dust.momx = player.mo.momx*2/3
					dust.momy = player.mo.momy*2/3
					
					if player.mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER)
						dust.state = S_SPINDUST_BUBBLE1
					elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
						dust.state = S_SPINDUST_FIRE1
					else
						dust.state = S_SPINDUST1
					end
					
					if i != 0
						if i == 1
							dust.angle = angle+ANGLE_112h
						elseif i == 2
							dust.angle = angle+ANGLE_247h
						elseif i == 3
							dust.angle = angle+ANGLE_112h+ANGLE_22h*3/2
						elseif i == 4
							dust.angle = angle+ANGLE_247h-ANGLE_22h*3/2
						end
						P_TryMove(dust,
						dust.x+P_ReturnThrustX(nil,angle,player.mo.radius*2),
						dust.y+P_ReturnThrustY(nil,angle,player.mo.radius*2),
						false)
						P_Thrust(dust,dust.angle,5*dust.scale)
					end
				end
				i = $ + 1
			end

		//Literally just the Spindash dust code from SRB2 Sonic which was
		//from SRB2's source code
		elseif ((player.panim == PA_RUN and not player.powers[pw_super])
		or ((player.mo.state == S_PLAY_SKIPSLIDE or player.mo.state == S_PLAY_SKIPTRANSITION)
		and (player.powers[pw_shield] & SH_NOSTACK) != SH_ELEMENTAL))
		and P_IsObjectOnGround(player.mo) and not (player.pflags&PF_STARTDASH)
			local i = 0 while i <= (leveltime%7)/2 // 1, 2, 3 or 4 particles
				local particle
				if player.mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER)
					particle = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_SMALLBUBBLE)
				else
					particle = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_SPINDUST)
					if (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
						particle.state = S_SPINDUST_FIRE1
					end
				end
				
				particle.target = player.mo
				particle.destscale = (2*player.mo.scale)/3
				P_SetScale(particle, particle.destscale)
				if (player.mo.eflags & MFE_VERTICALFLIP) // readjust z position if needed
					particle.z = player.mo.z + player.mo.height - particle.height
				end
				local prandom = {}
				prandom[0] = P_RandomFixed()<<2 // P_RandomByte()<<10
				prandom[1] = P_RandomRange(-30, 30) // P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT
				prandom[2] = P_RandomFixed()<<3 // P_RandomByte()<<11
				P_SetObjectMomZ(particle, player.maxdash/50 + prandom[0], false)
				P_InstaThrust(particle,
						player.drawangle + (prandom[1]*ANG1),
						-FixedMul(player.maxdash/12 + FRACUNIT + prandom[2], player.mo.scale))
				particle.momx = $+player.mo.momx
				particle.momy = $+player.mo.momy
				P_TryMove(particle, particle.x+particle.momx, particle.y+particle.momy, true)
				
				i = $+1
			end
		end
		
		-- Mystic Super shenanigans
		if player.mysticsuper
			if player.powers[pw_shield] --Picked up a shield? Save it for later.
			player.lastmysticshield = player.powers[pw_shield]
			player.powers[pw_shield] = 0
			P_SpawnShieldOrb(player)
			end
			
			if (player.mo.state == S_PLAY_SKIPALTDIVE or player.mo.state == S_PLAY_SKIPDIVE)
			and (player.speed > 120*FRACUNIT)
			player.mo.ghs = P_SpawnGhostMobj(player.mo)
			player.mo.ghs.tics = P_RandomRange(3,4)
			
			elseif (player.mo.state == S_PLAY_SKIPSLIDE or player.mo.state == S_PLAY_SKIPTRANSITION) --FLUDD is finally here
			and P_GetPlayerControlDirection(player) == 1 and P_IsObjectOnGround(player.mo) and (player.speed < 140*FRACUNIT)
			
			P_Thrust(player.mo, player.mo.angle, 76000)
			player.mo.ghs = P_SpawnGhostMobj(player.mo)
			player.mo.ghs.tics = P_RandomRange(3,5)
			end
			
		elseif player.lastmysticshield
			player.powers[pw_shield] = player.lastmysticshield
			P_SpawnShieldOrb(player)
			player.lastmysticshield = nil
		end
		
		//Bonk Code, activated after the mobjcollide and significant speed was lost.
		
		local mobj = player.mo -- Just for laziness.
		if mobj.readyforbonk	
			if ( (mobj.readyforbonk > 12*FRACUNIT and player.speed < mobj.readyforbonk/4)
			or (player.powers[pw_shield] & ~(SH_FORCEHP|SH_STACK)) == SH_FORCE
			or mobj.skipwiredive )
			and player.powers[pw_justlaunched] != 2
				mobj.momx = mobj.readyforbonkx //Necessary for P_BounceMove to function properly.
				mobj.momy = mobj.readyforbonky
				P_BounceMove(mobj)
				mobj.momx = $/2 mobj.momy = $/2
				P_SetObjectMomZ(mobj, mobj.player.jumpfactor*(39/4), false)
				mobj.skipdove = false
				mobj.player.pflags = $|PF_JUMPED&~PF_DRILLING&~PF_SPINNING
				//Force Walljump
				if (player.powers[pw_shield] & ~(SH_FORCEHP|SH_STACK)) == SH_FORCE
					mobj.state = S_PLAY_SKIPCANCEL
					if not mobj.player.powers[pw_super]
						mobj.player.pflags = $|PF_SHIELDABILITY
					end
					mobj.player.secondjump = 69
					if not P_IsObjectOnGround(mobj)
						mobj.momz = $*5/4
					end
					S_StartSound(mobj, sfx_ngskid)
				else
					skipcircle(mobj, MT_SUPERSPARK, 8*mobj.scale, true,
					R_PointToAngle2(mobj.readyforbonkx, mobj.readyforbonky, 0, 0))
					if mobj.player == displayplayer
					or mobj.player == secondarydisplayplayer
						P_StartQuake(10*mobj.scale, 7)
					end
					if P_IsObjectOnGround(mobj) --Fixes a pain bug
					mobj.z = $+(FRACUNIT*P_MobjFlip(mobj))
					end
					mobj.player.pflags = $&~PF_SHIELDABILITY
					mobj.skipdivehit = 1
					S_StartSound(mobj,sfx_s3k9e)
				end
			end
		mobj.readyforbonk = nil
		mobj.readyforbonkx = 0
		mobj.readyforbonky = 0
		end
		
		//Jump Dust
		if player.pflags&PF_STARTJUMP and not (player.pflags&PF_THOKKED)
		and not player.secondjump and not player.climbing
			if player.juum
				player.juum = false
				P_SpawnMobjFromMobj(player.mo,0,0,0,MT_DUST)
			end
		else
			player.juum = P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR
		end
		
		//Ledge grab climbing
		if player.climbing and player.mo.health
			player.charability = CA_GLIDEANDCLIMB
			player.camerascale = skins[player.skin].camerascale/2
			player.glidetime = max($, 2)
			
			player.pflags = $ | PF_STASIS
			if player.climbing != 1
				player.pflags = $ | PF_JUMPSTASIS
			end
		elseif player.charability == CA_GLIDEANDCLIMB
			player.charability = skins[player.skin].ability
			player.camerascale = skins[player.skin].camerascale
		end
		
		if ((player.mo.state == S_PLAY_SKIPCANCEL and player.panim == PA_DASH
		and player.powers[pw_nocontrol]) or player.climbing)
		and (player == displayplayer or player == secondarydisplayplayer)
			local cam = player == displayplayer and camera or camera2
			
			cam.momx = $/2
			cam.momy = $/2
			cam.momz = $/2
		end
		
		//Disallows the rest of the code in certain circumstances
		if P_PlayerInPain(player)
		or (player.pflags & PF_SLIDING)
		or player.powers[pw_carry] != CR_NONE
		or player.spectator
		or player.playerstate != PST_LIVE
		or not player.mo.health
		or (player.panim == PA_PAIN and not (player.pflags & PF_JUMPED))
		or player.powers[pw_super] == 1
		or player.iseggrobo
		or (player.powers[pw_nocontrol] and not player.mo.skipcrouching)
			resetskip(player)
		return end
		
		//Roll off ledges!
		if player.mo.state == S_PLAY_RUN and not P_IsObjectOnGround(player.mo)
			player.mo.state = S_PLAY_SKIPCANCEL
			if not (player.pflags & PF_JUMPED)
				player.pflags = $ | P_GetJumpFlags(player)
			end
		end
		
		//Charge Dive stuff
		if player.mo.chargedive and (player.mo.skipdivehit or P_IsObjectOnGround(player.mo))
			local i=0 while i<10 S_StopSound(player.mo) i=$+1 end
			if player.mo.skipdivehit
				S_StartSound(player.mo,sfx_s3k9e)
			end
			player.mo.chargedive = 0
		elseif player.mo.chargedive
			player.mo.chargedive = $-1
			player.drawangle = player.mo.angle
			player.mo.momz = 0
			if not (player.cmd.buttons&BT_SPIN)
				local maxthrust = abs(player.mo.chargedive-(TICRATE*2))*player.mo.scale*3/2
				local minthrust = skipdive(player)
				P_InstaThrust(player.mo, player.mo.angle,
				max(maxthrust, minthrust))
				local i=0 while i<10 S_StopSound(player.mo) i=$+1 end
				S_StartSound(player.mo,sfx_s3k98)
				if maxthrust > minthrust
					//S_StartSoundAtVolume(player.mo, sfx_s3k81, 196)
					S_StartSound(player.mo,sfx_kc5b)
					skipcircle(player.mo, MT_SUPERSPARK, 4*player.mo.scale, true, player.drawangle)
					player.mo.state = S_PLAY_SKIPDIVE
				else
					skipcircle(player.mo, MT_DUST, 4*player.mo.scale, true, player.drawangle)
					player.mo.state = S_PLAY_SKIPALTDIVE
				end
				
				if player.secondjump or maxthrust > minthrust
					if player.mo.eflags&MFE_UNDERWATER
						P_SetObjectMomZ(player.mo, (player.jumpfactor*(39/4)/4), false)
					else
						P_SetObjectMomZ(player.mo, (player.jumpfactor*(39/4)/2), false)
					end
				elseif player.mo.eflags&MFE_UNDERWATER
					P_SetObjectMomZ(player.mo, (player.jumpfactor*(39/4)/2), false)
				else
					P_SetObjectMomZ(player.mo, player.jumpfactor*(39/4), false)
				end
				player.mo.chargedive = 0
		
			elseif player.mo.chargedive <= 0
				P_InstaThrust(player.mo, player.mo.angle, 128*player.mo.scale)
				P_BlackOw(player)
				skipcircle(player.mo, MT_SUPERSPARK, 4*player.mo.scale, true, player.drawangle)
				player.mo.state = S_PLAY_SKIPDIVE
				
				if player.mo.eflags&MFE_UNDERWATER
					P_SetObjectMomZ(player.mo, (player.jumpfactor*(39/4)/4), false)
				else
					P_SetObjectMomZ(player.mo, (player.jumpfactor*(39/4)/2), false)
				end
				player.mo.chargedive = 0
				
			elseif player.mo.chargedive < (TICRATE*2)-5
				player.mo.momx = FixedMul($, FRACUNIT*94/100)
				player.mo.momy = FixedMul($, FRACUNIT*94/100)
				if (player.mo.chargedive < 15) --Make it more obvious when you're about to blow up your shield.
					if (player.mo.chargedive == 14)
					S_StartSound(player.mo, sfx_kc4d)
					end
					P_SpawnMobj(player.mo.x+P_RandomRange(-90, 90)*player.mo.scale, player.mo.y+P_RandomRange(-90, 90)*player.mo.scale, player.mo.z+P_RandomRange(-20, 70)*player.mo.scale, MT_SPARK)
				end
				if not (leveltime%2)
					local ghost = P_SpawnGhostMobj(player.mo)
					if ghost and ghost.valid
						ghost.momx = player.mo.momx
						ghost.momy = player.mo.momy
						ghost.momz = player.mo.momz
						ghost.destscale = player.mo.scale*3/2
						//Don't draw the ghosts if you're in first person
						//and you're the one spawning them (hopefully netsafe)
						if not verydangerouschasecamvariable and player == displayplayer
							ghost.flags2 = $|MF2_DONTDRAW
						end
					end
				end
			end
		end
		
		//Wire Dive stuff
		if player.mo.skipwiredive
			if player.mo.skipdove
				player.mo.skipwiredive = $-1
			else
				player.mo.skipwiredive = 0
			end
			P_SpawnGhostMobj(player.mo)
			if player.mo.skipwiredive == 0
				if player.secondjump > 1
					player.secondjump = 69
				end
				player.pflags = $&~PF_SHIELDABILITY
				player.mo.momx = $/4
				player.mo.momy = $/4
				S_StartSoundAtVolume(player.mo, sfx_s3kd6s, 128)
			else
				player.mo.momz = 0
				P_InstaThrust(player.mo, player.mo.skipwiredivedir, 80*player.mo.scale)
				player.drawangle = player.mo.skipwiredivedir
			end
		end
		
		//Restore your jump abilities when you land with the Bubble Shield
		if player.secondjump == 255
			player.mo.state = S_PLAY_SKIPDIVE
			player.pflags = $|PF_JUMPED&~PF_THOKKED&~PF_SHIELDABILITY
			player.mo.momz = $*3/2
			player.secondjump = 0
		end
		
		//Cancel the Elemental Stomp right before you hit the ground
		if (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
		and player.pflags&PF_SHIELDABILITY
			local z = player.mo.z
			local floor = z
			local floor2 = z
			local momz = (player.mo.momz + P_GetMobjGravity(player.mo))*-P_MobjFlip(player.mo)
			if (player.mo.eflags&MFE_VERTICALFLIP)
				z = $+player.mo.height
				floor = P_CeilingzAtPos(player.mo.x,
				player.mo.y, player.mo.z, player.mo.height)
				floor2 = P_CeilingzAtPos(player.mo.x + player.mo.momx,
				player.mo.y + player.mo.momy, player.mo.z + player.mo.momz, player.mo.height)
			else
				floor = P_FloorzAtPos(player.mo.x,
				player.mo.y, player.mo.z, player.mo.height)
				floor2 = P_FloorzAtPos(player.mo.x + player.mo.momx,
				player.mo.y + player.mo.momy, player.mo.z + player.mo.momz, player.mo.height)
			end
			if (floor - z)*-P_MobjFlip(player.mo) <= momz
			or (floor2 - z)*-P_MobjFlip(player.mo) <= momz
				player.pflags = $&~PF_SHIELDABILITY
				if player == displayplayer or player == secondarydisplayplayer
					P_StartQuake(40*player.mo.scale, 7)
				end
				P_ElementalFire(player, true)
				S_StartSound(player.mo,sfx_s3k5f)
				P_RadiusAttack(player.mo, player.mo, RING_DIST, DMG_FIRE)
				skipcircle(player.mo, MT_DUST, 16*player.mo.scale, false, player.drawangle)
				player.mo.momx = $*4/3
				player.mo.momy = $*4/3
			end
		end
		
		//Reset the variables on landing on the ground
		if player.mo.eflags & MFE_JUSTHITFLOOR and not (player.pflags&PF_JUMPED)
			local stupid = false
			//Start a slide after a dive
			if player.mo.skipdove
				stupid = true
				player.mo.state = S_PLAY_SKIPTRANSITION
				player.mo.momx = $*3/4
				player.mo.momy = $*3/4
				player.pflags = $|PF_SPINNING
			end
			resetskip(player)
			//Window of time for the perfect dive recovery
			if stupid then player.mo.skipperfectwindow = 5 end
			
		//Decrease the timer for it
		elseif player.mo.skipperfectwindow
			player.mo.skipperfectwindow = $-1
		end
		
		//Cancel the dive or bonk if you hit a spring
		if (player.mo.skipdove or player.mo.skipdivehit)
		and player.mo.eflags & MFE_SPRUNG
			player.mo.state = S_PLAY_SKIPCANCEL
			resetskip(player)
		end
		
		//Ya sprung? Ya get your jump ability back
		if player.mo.eflags & MFE_SPRUNG and not P_IsObjectOnGround(player.mo)
			player.pflags = $|PF_JUMPED&~PF_THOKKED
		end
		
		//Crouchin'!
		if player.mo.skipcrouching
			if player.mo.ceilingz - player.mo.floorz < FixedMul(skins[player.mo.skin].height, player.mo.scale)
				player.pflags = $ | PF_FULLSTASIS
			end
			//Cancel the crouch
			if not (player.cmd.buttons & BT_SPIN or player.mo.skipmenu)
			or not P_IsObjectOnGround(player.mo) or player.pflags&PF_SPINNING
				if player.pflags&PF_SPINNING
					player.mo.state = S_PLAY_ROLL
				elseif P_IsObjectOnGround(player.mo)
					player.mo.state = S_PLAY_STND
				else
					player.mo.state = S_PLAY_SPRING
				end
				player.mo.skipmenu = false
				player.mo.skipcrouching = false
				player.height = skins[player.mo.skin].height
				player.normalspeed = skins[player.mo.skin].normalspeed
				
			//Normal stuff
			else
				if PlusLoaded and player.powers[pw_shield] == SH_SPIKESHIELD
					//Ain't this silly
				elseif player.mo.skipmenu
					player.mo.state = S_PLAY_CRFT
					player.mo.frame = ($ &~ FF_FRAMEMASK) | ((leveltime%64)/16) //I really hate SRB2
				else
					player.mo.state = S_PLAY_SKIPCROUCH
					player.mo.frame = ($ &~ FF_FRAMEMASK) | ((leveltime%16)/4) //I really REALLY hate SRB2
					player.panim = PA_IDLE
				end
				player.powers[pw_noautobrake] = max($,1)
				player.height = skins[player.mo.skin].spinheight
				player.normalspeed = 0
				//Monitor Crafting
				if player.mo.skipmenu and (player.exiting or G_IsSpecialStage())
					player.mo.skipmenu = false
				elseif player.mo.skipmenu
					local monitorcost = skipcost[skipcraftlist[player.skipselection]] //Cost
					if type(monitorcost) != "number" then monitorcost = 15 end
					if All7Emeralds(emeralds) //Emerald Discount
						monitorcost = FixedFloor($*FRACUNIT*3/4)/FRACUNIT
					end
					
					//Set our angle so we don't turn while in the menu
					player.drawangle = player.mo.skipcrouchdir
					if player.pflags&PF_DIRECTIONCHAR and player.pflags&PF_ANALOGMODE
						player.mo.angle = player.cmd.angleturn<<16
					end
					
					//Menu Selection
					if player.righttapping
						player.skipselection = $+1
						if player.skipselection > skiptotalcraft
							player.skipselection = 0
						end
						S_StartSound(player.mo, sfx_s3kb7, player)
					elseif player.lefttapping
						player.skipselection = $-1
						if player.skipselection < 0
							player.skipselection = skiptotalcraft
						end
						S_StartSound(player.mo, sfx_s3kb7, player)
						
					//Crafting
					elseif player.jumptapping
						//Spawn it if we have enough scraps
						if player.skipscrap >= monitorcost or CV_FindVar("infinitescrap").value
							local monitor
							monitor = P_SpawnMobjFromMobj(player.mo,0,0,0,
							skipcraftlist[player.skipselection])
							//Set the monitor's things and apply the cost
							if monitor and monitor.valid
								player.mo.flags = $|MF_NOCLIPTHING
								P_TryMove(monitor, player.mo.x+P_ReturnThrustX(nil, player.drawangle, player.mo.radius*4),
								player.mo.y+P_ReturnThrustY(nil, player.drawangle, player.mo.radius*4), true)
								player.mo.flags = $&~MF_NOCLIPTHING
								S_StartSound(player.mo,sfx_kc5b) --sound effect for emphasis
								S_StartSound(player.mo, sfx_addfil, player)
								S_StartSoundAtVolume(player.mo, sfx_cdpcm8, 196)
								skipcircle(monitor, MT_DUST, 4*player.mo.scale, true, player.drawangle)
								skipcircle(monitor, MT_DUST, 4*player.mo.scale, true, player.drawangle+ANGLE_90)
								if not CV_FindVar("infinitescrap").value
									player.skipscrap = $-monitorcost -- bap, there goes some of your scrap
								end
								monitor.skipthrown = true
								if not (monitor.flags&MF_GRENADEBOUNCE)
									monitor.skipskip = player.mo
									monitor.skipgrace = TICRATE
								end
								P_SetScale(monitor, player.mo.scale/2)
								player.mo.skipmenu = false
								
							else //If the monitor somehow got removed, play an error sound
								S_StartSound(player.mo, sfx_adderr, player)
							end
						else //Not enough!
							S_StartSound(player.mo, sfx_notadd, player)
						end
					end
				//Get the angle before going into the menu
				else
					player.mo.skipcrouchdir = player.drawangle
					if player.jumptapping and not player.exiting
					and not G_IsSpecialStage()
						S_StartSound(player.mo, sfx_cdfm23, player)
						player.skipselection = $ or 0
						player.mo.skipmenu = true
						//Thank you RadicalSoda :]
						if not SkipHUDWarning and player == consoleplayer
						and not CV_FindVar("showhud").value
							CONS_Printf(player, "\x82 WARNING:\x80 Skip's Crafting Menu requires the HUD to be on to be seen!", " Do\x84 showhud on\x80 in console to turn it back on.")
							SkipHUDWarning = true
						end
					end
				end
			end
		//Start a crouch
		elseif player.cmd.buttons & BT_SPIN and P_IsObjectOnGround(player.mo)
		and P_GetPlayerControlDirection(player) == 0 and not player.hugging
		and not (player.pflags & (PF_SPINNING|PF_JUMPED|PF_STASIS))
		//and not (player.mo.eflags & MFE_JUSTHITFLOOR)
		and (player.spintapping or (not player.skipsmug 
		and player.mo.state != S_PLAY_FIRE
		and player.mo.state != S_PLAY_FIRE_FINISH))
			if PlusLoaded and player.powers[pw_shield] == SH_SPIKESHIELD
				S_StartSound(player.mo, sfx_spin)
			end
			player.mo.state = S_PLAY_SKIPCROUCH
			player.mo.skipcrouching = true
			S_StopSoundByID(player.mo, sfx_skpwin)
		end
		
		//Bonkin'!
		if player.mo.skipdivehit
			if P_IsObjectOnGround(player.mo)
			or player.mo.skipdivehit > TICRATE*5
			or player.mo.eflags & MFE_SPRUNG
				player.mo.skipdivehit = 0
				player.mo.rollangle = 0
				player.mo.state = S_PLAY_FALL
			else
				player.mo.skipdivehit = $+1
				player.mo.rollangle = $ + ANGLE_22h
				player.pflags = $ | PF_FULLSTASIS
				player.mo.state = S_PLAY_SKIPBONK
				player.mo.momz = $ + P_GetMobjGravity(player.mo)
			end
		
		//Slidin'!
		elseif player.mo.state == S_PLAY_SKIPSLIDE
		or player.mo.state == S_PLAY_SKIPTRANSITION
			player.pflags = $|PF_SPINNING
			
			if P_IsObjectOnGround(player.mo)
				if not (leveltime % 5)
					S_StartSound(player.mo, sfx_s3k7e)
					//P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
				end
				
				//Make the slide usable for rising Spindashable platforms
				local sectorthing = player.mo.subsector and player.mo.subsector.sector
				if sectorthing and sectorthing.valid then
					for fof in sectorthing.ffloors()
						if fof.valid and (abs(fof.topheight - player.mo.z) <= 40*player.mo.scale
						or abs(fof.bottomheight - player.mo.z+player.mo.height) <= 40*player.mo.scale)
						and fof.master and fof.master.valid and fof.master.flags&ML_NOCLIMB
						and (fof.master.special == 153 or fof.master.special == 180
						or (fof.master.special >= 150 and fof.master.special <= 152)
						or (fof.master.special >= 190 and fof.master.special <= 195)
						or fof.master.special == 176 or fof.master.special == 177)
							player.pflags = $|PF_STARTDASH
							P_InstaThrust(player.mo,0,0)
						end
					end
				end
			else
				player.mo.state = S_PLAY_SKIPCANCEL
				player.pflags = $&~PF_SPINNING
				if not (player.pflags & PF_JUMPED)
					player.pflags = $ | P_GetJumpFlags(player)
				end
			end
			
		//Divin'!
		elseif player.mo.skipdove
			player.mo.momz = $ + P_GetMobjGravity(player.mo)*2/5
			if not (player.pflags&PF_JUMPED) and player.pflags&PF_SHIELDABILITY
				player.pflags = $|PF_JUMPED
			end
		
		//Super stuff
		elseif player.powers[pw_super] and not P_IsObjectOnGround(player.mo)
			//Super float
			if player.cmd.buttons & BT_JUMP
			and player.pflags & PF_JUMPED
			and not (player.pflags & (PF_SPINNING | PF_SHIELDABILITY))
			and not player.climbing and player.secondjump != 255
			and player.mo.momz*P_MobjFlip(player.mo) < 0
				if player.panim != PA_WALK and player.panim != PA_RUN
					if player.speed >= FixedMul(player.runspeed, player.mo.scale)
						player.mo.state = S_PLAY_FLOAT_RUN
					else
						player.mo.state = S_PLAY_FLOAT
					end
				end
				
				if player.speed > 5*player.mo.scale
					player.mo.momz = 0
				end
				player.pflags = $ &~ PF_STARTJUMP | PF_NOJUMPDAMAGE
			end
			
			//Attraction Shield reticle
			if (player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT
			and not (player.pflags & PF_SPINDOWN)
				local enemy = P_LookForEnemies(player, false, false)
				if enemy
					P_SpawnLockOn(player, enemy, S_LOCKON2)
				end
			end
			
		//Attraction Shield reticle
		elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT
		and player.pflags & PF_THOKKED and not (player.pflags & PF_SPINDOWN)
			local enemy = P_LookForEnemies(player, false, false)
			if enemy
				P_SpawnLockOn(player, enemy, S_LOCKON2)
			end
		end
		
		//Smug Dance
		if player.skipsmug
		and not (player.hugging)
			player.panim = PA_DASH
			if not (P_IsObjectOnGround(player.mo) and not player.mo.skipdove
			and player.mo.state != S_PLAY_SKIPSLIDE
			and player.mo.state != S_PLAY_SKIPTRANSITION
			and not player.mo.skipcrouching) or player.skiptosstapping
				if player.mo.state == S_PLAY_SKIPSMUG
					player.mo.state = S_PLAY_STND
				end
				player.skipsmug = false
				P_RestoreMusic(player)
			else
				if player.mo.state != S_PLAY_SKIPSMUG
					player.mo.state = S_PLAY_SKIPSMUG
				end
				player.pflags = $|PF_FULLSTASIS
			end
		elseif P_IsObjectOnGround(player.mo) and not player.mo.skipdove
		and player.mo.state != S_PLAY_SKIPSLIDE
		and player.mo.state != S_PLAY_SKIPTRANSITION
		and not (player.pflags & PF_STASIS)
		and player.skiptosstapping
			if player.mo.skipcrouching
				player.mo.state = S_PLAY_FIRE
				S_StartSound(player.mo, sfx_skpwin)
				
				player.mo.skipmenu = false
				player.mo.skipcrouching = false
				player.height = skins[player.mo.skin].height
				player.normalspeed = skins[player.mo.skin].normalspeed
			else
				player.skipsmug = true
				P_PlayJingleMusic(player, "SMUGDANCE", nil, true, JT_OTHER)
			end
		end
		if player.skipsmug --After 20 seconds, spawn funky color particles
			player.mo.skipsmugtimer = player.mo.skipsmugtimer and $+1 or 1
			local p = player //Laziness again. A large part of this is imported from SMS.
			local s = player.mo
			if (s.skipsmugtimer > 785)
				if leveltime & 1
					local dumb = ((leveltime/2) & 1) or -1
					local ghost = P_SpawnGhostMobj(player.mo)
					if ghost.tracer then P_RemoveMobj(ghost.tracer) end
					
					ghost.color = SKINCOLOR_SUPERSILVER5 + 5*((leveltime/4) % 7)
					ghost.colorized = true
					ghost.blendmode = AST_ADD
					ghost.fuse = $*2
					
					P_Thrust(ghost, player.cmd.angleturn<<16 + ANGLE_90,
					(player.mo.scale*2+FixedMul(P_RandomFixed(), player.mo.scale*2))*dumb)
					
					P_TryMove(ghost,
					ghost.x + P_ReturnThrustX(nil, player.cmd.angleturn<<16, player.mo.scale),
					ghost.y + P_ReturnThrustY(nil, player.cmd.angleturn<<16, player.mo.scale),
					true)
				end
				
				if (s.skipsmugtimer == 786)
					local ztotal = 0							
					for z in players.iterate
						if z.mo and z.mo.skipsmugtimer and (z.mo.skipsmugtimer > 785)
							ztotal = $+1
						end
					end
					if (ztotal > 3) --Any more than 3 and we'll cause lag if people all dance in the same spot, which is likely.
						s.skipsmugtimer = 1
					else
						if p.mysticsuper
							P_FlashPal(p, PAL_NUKE, 10)
							S_StartSound(s, sfx_bkpoof)
							S_StartSound(s, sfx_rumble)	
							P_NukeEnemies(s, s, 1500*FRACUNIT)
						else
							P_FlashPal(p, PAL_RECYCLE, 10)
						end
					end
				end
				if p.mysticsuper --The Dance...of DESTRUCTION!!
					if (s.frame == 1048580 or s.frame == 1048577)
					and (p.anim_duration == 1 or s.tics == 1)
					P_NukeEnemies(s, s, 1500*FRACUNIT)  --Destroy everything in the rhythm of your dancing
					end
					if p == displayplayer or p == secondarydisplayplayer --Let's not bother other players with this.
						P_StartQuake(P_RandomRange(10,60)*s.scale, 1)
					end
				  	for d = 1,2 --Blow shit up. Blow shit up! Blow shit up!!
						if (P_RandomRange(0, 1))
						s.smuggfx = P_SpawnMobj(s.x+((P_RandomRange(FixedMul(-1250, s.scale), FixedMul(1250, s.scale)))*FRACUNIT), s.y+((P_RandomRange(FixedMul(-1250, s.scale), FixedMul(1250, s.scale)))*FRACUNIT), s.z+((P_RandomRange(FixedMul(150, s.scale), FixedMul(-120, s.scale)))*FRACUNIT), MT_BOSSEXPLODE)
						else
						s.smuggfx = P_SpawnMobj(s.x+((P_RandomRange(FixedMul(-1250, s.scale), FixedMul(1250, s.scale)))*FRACUNIT), s.y+((P_RandomRange(FixedMul(-1250, s.scale), FixedMul(1250, s.scale)))*FRACUNIT), s.z+((P_RandomRange(FixedMul(150, s.scale), FixedMul(-120, s.scale)))*FRACUNIT), MT_BOSSEXPLODE)
						end
						if s.smuggfx and s.smuggfx.valid
							s.smuggfx.target = s
							s.smuggfx.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP
							s.smuggfx.frame = $+P_RandomRange(0,2)
							s.smuggfx.frame = $|FF_FULLBRIGHT
							s.smuggfx.scale = s.scale*10/P_RandomRange(1,10)
							s.smuggfx.scalespeed = $/P_RandomRange(1,12)
							s.smuggfx.destscale = s.scale*20
							s.smuggfx.momz = $+P_RandomRange(0,10)*FRACUNIT
							if not P_RandomRange(0,11)
								if not P_RandomRange(0,1)
									S_StartSound(s.smuggfx, P_RandomRange(sfx_rocks1, sfx_rocks4))
								else
									S_StartSound(s.smuggfx, sfx_brakrx)
								end
							end
						end
				  	end
				else --Smugness-induced hallucinations.
					if (P_RandomRange(0, 1))
						s.smuggfx = P_SpawnMobj(s.x+((P_RandomRange(FixedMul(-750, s.scale), FixedMul(750, s.scale)))*FRACUNIT), s.y+((P_RandomRange(FixedMul(-750, s.scale), FixedMul(750, s.scale)))*FRACUNIT), s.z+((P_RandomRange(FixedMul(150, s.scale), FixedMul(-120, s.scale)))*FRACUNIT), MT_THOK)
					else				
						s.smuggfx = P_SpawnMobj(s.x+((P_RandomRange(FixedMul(-350, s.scale), FixedMul(350, s.scale)))*FRACUNIT), s.y+((P_RandomRange(FixedMul(-350, s.scale), FixedMul(350, s.scale)))*FRACUNIT), s.z+((P_RandomRange(FixedMul(40, s.scale), FixedMul(-120, s.scale)))*FRACUNIT), MT_BOXSPARKLE)
					end
					if s.smuggfx
						s.smuggfx.target = s
						s.smuggfx.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP
						P_SetObjectMomZ(s.smuggfx, ((P_RandomRange(2, 6))*FRACUNIT))	
						if (s.smuggfx.type == MT_THOK)
							s.smuggfx.frame = $|TR_TRANS40|FF_FULLBRIGHT
							s.smuggfx.color = P_RandomRange(SKINCOLOR_SUPERSILVER1, SKINCOLOR_SUPERTAN5)
							s.smuggfx.scale = s.scale*3/P_RandomRange(1,6)
							s.smuggfx.scalespeed = $/12
							s.smuggfx.destscale = s.scale*2
							s.smuggfx.tics = 100
						else --Box Sparkle
							if P_RandomRange(0,1)
								s.smuggfx.rollangle = FixedAngle(45*FRACUNIT)
							end
							s.smuggfx.fuse = 100			
							s.smuggfx.scale = s.scale*2/P_RandomRange(1,4)
							s.smuggfx.destscale = s.scale*(P_RandomRange(4, 8))
							s.smuggfx.tics = 40
						end
					end
				end
			end
		elseif player.mo.skipsmugtimer
			player.mo.skipsmugtimer = 0
		end
		
		//Winner!
		if player.exiting and player.mo.state != S_PLAY_FIRE_FINISH
		and player.panim == PA_IDLE
		and (player.skiptosstapping or not player.mo.skipcrouching)
			player.mo.state = S_PLAY_FIRE
			S_StartSound(player.mo, sfx_skpwin)
		end
		
		if player.mo.state == S_PLAY_FIRE
			player.pflags = $ | PF_STASIS
			
		elseif player.mo.state == S_PLAY_FIRE_FINISH
			player.panim = PA_IDLE
			if (player.mo.tics == 1 and player.cmd.buttons & BT_SPIN)
			or player.exiting
				player.mo.tics = 2
			end
		end
		
	//Not Skip
	else
		if player.skipflashlight and player.skipflashlight.valid
			P_KillMobj(player.skipflashlight)
		end
		if player.skipsmug
			if player.mo.state == S_PLAY_SKIPSMUG
				player.mo.state = S_PLAY_STND
			end
			player.skipsmug = false
			P_RestoreMusic(player)
		end
		if player.mo and player.mo.valid and player.mo.skin == "fehn"
			R_SetPlayerSkin(player, "skip")
			player.mo.state = S_PLAY_SKIPSMUG
			player.skipsmug = true
			P_PlayJingleMusic(player, "SMUGDANCE", nil, true, JT_OTHER)
		end
	end
end)

//Automatically start sliding if you're about to be crushed
//And monitors thrown by Skip don't crush players
addHook("ShouldDamage", function(target, inflictor, source, damage, damagetype)
	if target and target.valid and target.player
		if inflictor == nil and source == nil and target.skin == "skip"
		and damagetype == DMG_CRUSHED and P_IsObjectOnGround(target)
		and target.ceilingz - target.floorz >= FixedMul(skins[target.skin].spinheight, target.scale)
			target.state = S_PLAY_SKIPTRANSITION
			target.player.pflags = $|PF_SPINNING&~PF_JUMPED&~PF_THOKKED
			resetskip(target.player)
			return false
		elseif inflictor and inflictor.valid and inflictor.flags&MF_MONITOR
		and inflictor.skipthrown
			return false
		end
	end
end, MT_PLAYER)

//Make it so that when Skip spawns a monitor, he has a grace-period in which
//the monitor cannot be broken by anyone else but him
local function skipmonitorgrace(mobj)
	if mobj and mobj.valid and mobj.skipgrace
		mobj.skipgrace = $-1
	end
end
for i = 0, skiptotalcraft
	addHook("MobjThinker", skipmonitorgrace, skipcraftlist[i])
end

//Same here
addHook("ShouldDamage", function(target, inflictor, source, damage, damagetype)
	if target and target.valid and target.flags&MF_MONITOR and target.skipthrown
	and target.skipgrace and target.skipskip and target.skipskip.valid
	and source != target.skipskip
		if source and source.valid and source.player
		and P_MobjFlip(source)*source.momz < 0
			if (source.player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
			and source.player.pflags&PF_SHIELDABILITY
				P_DoBubbleBounce(source.player)
			else
				S_StartSound(source, sfx_s3k7b)
				if source.player.pflags&PF_SHIELDABILITY
					source.player.pflags = $&~PF_SHIELDABILITY
				end
				source.momz = $*-1
			end
		end
		return false
	end
end)

//Make Skip-created monitors not leave behind their corpses
addHook("MobjDeath", function(target, inflictor, source, damage, damagetype)
	if target and target.valid and target.flags&MF_MONITOR and target.skipthrown
		target.fuse = 1
		target.target = source
		target.state = target.info.deathstate
		return true
	end
end)

//Same here
addHook("MobjFuse", function(target)
	if target and target.valid and target.flags&MF_MONITOR and target.skipthrown
		target.state = S_XPLD1
		return true
	end
end)

//Make Skip's attacks attack
addHook("PlayerCanDamage", function(player, mobj)
	if player.mo and player.mo.valid and player.mo.skin == "skip"
	and (player.mo.skipdove or player.mo.state == S_PLAY_SKIPCANCEL)
		return true
	end
end)

//Reset your variables when you spawn
//also resets your state, this plays Skip's idle properly when he spawns
addHook("PlayerSpawn", function(player)
	if player.skipscrap == nil
		if gametyperules&GTR_FRIENDLY and not modeattacking
			player.skipscrap = 40
		else
			player.skipscrap = 80
		end
	end
	if player.mo and player.mo.valid and player.mo.skin == "skip"
		resetskip(player)
		player.skipyoffset = 0
		player.skiplighton = false
		if player.mo.state == S_PLAY_STND
			player.mo.state = $
		end
	end
	
	if player.skipshield and gametyperules&GTR_FRIENDLY
	and not G_IsSpecialStage() and player.mo and player.mo.valid
	and (player.mo.skin == "skip" or skipbuddy(player))
		P_SwitchShield(player, player.skipshield)
		
		skipreloadcustomshield(player)
	end
end)

//Reset your scraps to 80 when first going into a competitive gametype level
addHook("MapLoad", function(mapnum)
	if gametyperules&GTR_FRIENDLY and not modeattacking then return end
	for player in players.iterate
		player.skipscrap = 80
	end
end)

//No normal shield abilities! We've got dive modification for that
addHook("ShieldSpecial", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "skip"
		if ESPLoaded and (player.powers[pw_shield] == SH_GRAVITY
		or player.powers[pw_shield] == SH_STAR
		or player.powers[pw_shield] == SH_GUM)
			player.pflags = $|PF_SHIELDABILITY
		end
		return true
	end
end)

//Kirby Support
if not(kirbyabilitytable)
    rawset(_G, "kirbyabilitytable", {})
end
kirbyabilitytable["skip"] = 7